/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PARFILIALGEP                                             */
/* Tabela : PARFILIALGEP                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 19/06/2008 - Luan Alison Cardoso de Carvalho                               */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PARFILIALGEP
BEFORE INSERT OR UPDATE OR DELETE
ON PARFILIALGEP FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPARFILG := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFILIAL ,0) <> NVL(:NEW.CDFILIAL ,0)) OR
        (NVL(:OLD.CDGRUPPROD ,0) <> NVL(:NEW.CDGRUPPROD ,0)) OR
        (NVL(:OLD.VRPEAPROTEMP ,0) <> NVL(:NEW.VRPEAPROTEMP ,0)) OR
        (NVL(:OLD.CDASSUMONIT ,0) <> NVL(:NEW.CDASSUMONIT ,0)) OR 
        (NVL(:OLD.CDPROCMONIT ,0) <> NVL(:NEW.CDPROCMONIT ,0)) OR
        (NVL(:OLD.CDPROCATEINT ,0) <> NVL(:NEW.CDPROCATEINT ,0)) OR
        (NVL(:OLD.CDPROCATEDES ,0) <> NVL(:NEW.CDPROCATEDES ,0)) OR
        (NVL(:OLD.DSDIRSAUTOTESTE ,0) <> NVL(:NEW.DSDIRSAUTOTESTE ,0)) OR
        (NVL(:OLD.CDGRUPMANUAPR ,0) <> NVL(:NEW.CDGRUPMANUAPR ,0)) OR
        (NVL(:OLD.QTHRPRODMANUCOR ,0) <> NVL(:NEW.QTHRPRODMANUCOR ,0)) OR
        (NVL(:OLD.QTHRPRODMANUEVO ,0) <> NVL(:NEW.QTHRPRODMANUEVO ,0)) OR
        (NVL(:OLD.QTHRPRODESPECIF ,0) <> NVL(:NEW.QTHRPRODESPECIF ,0)) OR
        (NVL(:OLD.QTHRPRODHOMOLOG ,0) <> NVL(:NEW.QTHRPRODHOMOLOG ,0)) OR
        (NVL(:OLD.QTHRPRODOPERACI ,0) <> NVL(:NEW.QTHRPRODOPERACI ,0)) OR
        (NVL(:OLD.CDITEMTRAB ,0) <> NVL(:NEW.CDITEMTRAB ,0)) OR
        (NVL(:OLD.CDPROATIVEXTFLP ,0) <> NVL(:NEW.CDPROATIVEXTFLP ,0)) OR
        (NVL(:OLD.CDPROCESSOGCO ,0) <> NVL(:NEW.CDPROCESSOGCO ,0)) OR
        (NVL(:OLD.CDPROCESSOQA ,0) <> NVL(:NEW.CDPROCESSOQA ,0)) OR
        (NVL(:OLD.CDOPERAUDITQA ,0) <> NVL(:NEW.CDOPERAUDITQA ,0)) OR
        (NVL(:OLD.CDOPERAUDITGCO ,0) <> NVL(:NEW.CDOPERAUDITGCO ,0)) OR
        (NVL(:OLD.CDGRUPCONDOCGEP ,0) <> NVL(:NEW.CDGRUPCONDOCGEP ,0)) THEN
        :NEW.DTULTATUPARFILG := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PARFILIALGEP', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PARFILIALGEP MODIFY DTULTATUPARFILG DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_PARFILIALGEP','5.11.007'); END;
/
