<?php 

namespace Teknisa\COC\Controllers;

use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\GER\Utilities\Environment;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO;
use \Doctrine\ORM\EntityManager;

class CustoApresentacao extends \Teknisa\GER\Controllers\TeknisaCrud {
    
    protected $entityManager;
    protected $dataSourceManager;
    protected $environment;
    protected $connection;
    protected $parameterBag;

    public function __construct($entityManager, Manager $dataSourceManager, Environment $environment, $connection, $parameterBag) {
        $this->entityManager = $entityManager;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
        $this->connection = $connection;
        $this->parameterBag = $parameterBag;
	}


    public function calculaCusto (DTO\Request\DataSet $request, DTO\Response $response){

		foreach ($request->getDataSet()->getRows() as $row) {

	        $connection = $this->entityManager->getConnection();
	        $procedure = new StoredProcedure($connection, 'CUSTO_APRESENTACAOCIAM');
	        $procedure->addParam(new Param('P_CDCIA', Param::PARAM_INPUT, $row['CDCIA'], Param::PARAM_TYPE_STR));
	        $procedure->addParam(new Param('P_NRAPRESENTACIA', Param::PARAM_INPUT, $row['NRAPRESENTACIA'], Param::PARAM_TYPE_STR));
	        $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $row['CDFILIAL'], Param::PARAM_TYPE_STR));
	        $procedure->addParam(new Param('P_DATACUSTO', Param::PARAM_INPUT, $row['DATACUSTO'], Param::PARAM_TYPE_STR));
	        $procedure->addParam(new Param('P_TIPOCUSTO', Param::PARAM_INPUT, $row['TIPOCUSTO'], Param::PARAM_TYPE_STR));
	        $procedure->addParam(new Param('P_NRORG', Param::PARAM_INPUT, $row['NRORG'], Param::PARAM_TYPE_STR));
	        $procedure->execute();

	    }
	}

    public function geraMateriaPrima (DTO\Request\DataSet $request, DTO\Response $response){

		foreach ($request->getDataSet()->getRows() as $row) {

	        $connection = $this->entityManager->getConnection();
	        $procedure = new StoredProcedure($connection, 'PROD_APRESENTACIA');
	        $procedure->addParam(new Param('P_CDCIA', Param::PARAM_INPUT, $row['CDCIA'], Param::PARAM_TYPE_STR));
	        $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $row['CDFILIAL'], Param::PARAM_TYPE_STR));
	        $procedure->addParam(new Param('P_NRAPRESENTACIA', Param::PARAM_INPUT, $row['NRAPRESENTACIA'], Param::PARAM_TYPE_STR));
	        $procedure->addParam(new Param('P_NRORG', Param::PARAM_INPUT, $row['NRORG'], Param::PARAM_TYPE_STR));
	        $procedure->addParam(new Param('P_CDCONTROLE', Param::PARAM_OUTPUT, '', Param::PARAM_TYPE_STR));
	        $resultado = $procedure->execute();
	        $response->addDataset(new DataSet('response', $resultado));
	    }
	}
} 