<?php

namespace Teknisa\COC\Controllers;

use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DTO\Response\Error;
use \Zeedhi\Framework\DataSource\DataSet;
use \Zeedhi\Framework\DataSource\FilterCriteria;
use \Zeedhi\Framework\DataSource\Manager;
use \Zeedhi\Framework\DataSource\ParameterBag;
use \Teknisa\GER\Services\CrudService;

class ExportacaoSAP extends \Teknisa\GER\Controllers\TeknisaCrud{

	protected $dataSourceName = 'lista';
	protected $exportacaoSAPService;
	protected $customFolder = 'exportDelivery';
	protected $newCode;
	protected $dataSourceManager;
	protected $enviroment;
	protected $parameterBagColumns = array();
	protected $messages;
	protected $connection;

	function __construct(CrudService $crudService, ParameterBag $parameterBag, $newCode, $dataSourceManager, $exportacaoSAPService, $enviroment, $connection){
		$this->dataSourceManager = $dataSourceManager;
        $this->newCode = $newCode;
		$this->exportacaoSAPService = $exportacaoSAPService;
		$this->enviroment = $enviroment;
		$this->connection = $connection;
		parent::__construct($crudService, $parameterBag);
	}

	public function downloadExport (DTO\Request $request, DTO\Response $response){
		$arquivo = $this->exportacaoSAPService->findArquivo(
			$_REQUEST['cdfilial'], $_REQUEST['cdcia'],
			$_REQUEST['dtinicio'], $_REQUEST['dtfim'],
			$_REQUEST['nrlista'], $_REQUEST['nrorg'],
			$_REQUEST['id'], $_REQUEST['exportname']
		);

		$this->exportacaoSAPService->updateDelivery(
			$_REQUEST['cdfilial'], $_REQUEST['cdcia'],
			$_REQUEST['dtinicio'], $_REQUEST['dtfim'],
			$_REQUEST['nrlista'], $_REQUEST['nrorg']
		);

		$fileContent = "";
		header('Accept-Ranges: none');
		header('Content-Description: File Transfer');
		header('Content-Type: application/octet-stream');
		header('Content-Transfer-Encoding: binary');
		header('Connection: Keep-Alive');
		header('Expires: 0');
		header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
		header('Pragma: public');
		header("Content-Disposition: attachment; filename=".$_REQUEST['filename'].".txt");
	    for($i=0; $i<count($arquivo); $i++) {
			echo $arquivo[$i]['CAMPOUNICO']."\r\n";
	    }
		exit;
	}

	public function downloadExportServ (DTO\Request $request, DTO\Response $response){
	    $fileContent = '';
		$servicos = $this->exportacaoSAPService->findArquivoServico($_REQUEST['cdfilial'], $_REQUEST['nrorg'], $_REQUEST['id'], $_REQUEST['cdcia'], $_REQUEST['dtultatu'], $_REQUEST['servico']);
		header('Accept-Ranges: none');
		header('Content-Description: File Transfer');
		header('Content-Type: application/octet-stream');
		header('Content-Transfer-Encoding: binary');
		header('Connection: Keep-Alive');
		header('Expires: 0');
		header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
		header('Pragma: public');
		header("Content-Disposition: attachment; filename=".$_REQUEST['fileName'].".txt");
	    for($i=0; $i<count($servicos); $i++) {
			echo $servicos[$i]['CAMPOUNICO']."\r\n";
	    }

		exit;
	}


	private function validaDelivery($nrlista, $cdfilial, $cdcia, $dtini, $dtfin, $exportName) {
		
		$exportIDDELIEXPSAP = '';
		
		if($exportName == '03'){
			$exportIDDELIEXPSAP = 'S';
		}else{
			$exportIDDELIEXPSAP = 'N';
		}

		$stmt = $this->connection->prepare("SELECT DISTINCT CO.SGCIA || ' ' || CO.NMCIA||' - '||SCF.DSSERVICOCIAFILI||' - '||CL.SGCLASSE||' - '||CI.IDCICLO||' - '||SG.SGUNIDADE AS DATA_ERROR FROM DELIVERYM DE INNER JOIN PLANOVOOM PV ON PV.CDFILIAL = DE.CDFILIAL AND PV.CDCIA = DE.CDCIA AND PV.NRVOO = DE.NRVOO AND PV.CDTRECHO = DE.CDTRECHO AND PV.DTHRPLAVOOPV = DE.DTHRPLAVOOPV INNER JOIN SERVPLANOM SE ON SE.CDFILIAL = DE.CDFILIAL AND SE.NRDELIVERY = DE.NRDELIVERY INNER JOIN SERVCICLO SCL ON SCL.CDFILIAL = SE.CDFILIAL AND SCL.CDCIA = SE.CDCIA AND SCL.NRSERVICOCIAFILI = SE.NRSERVICOCIAFILI AND SCL.CDCICLO = SE.CDCICLO AND SCL.CDCLASSE = SE.CDCLASSE INNER JOIN CLASSE CL ON CL.CDCLASSE = SCL.CDCLASSE INNER JOIN CICLO CI ON CI.CDCICLO = SCL.CDCICLO INNER JOIN SERVICOCIAFILI SCF ON SCF.CDFILIAL = SE.CDFILIAL AND SCF.CDCIA = SE.CDCIA AND SCF.NRSERVICOCIAFILI = SE.NRSERVICOCIAFILI INNER JOIN SERVICOGEN SG ON SG.NRSERVICOGEN = SCF.NRSERVICOGEN INNER JOIN COMPANHIA CO ON CO.CDCIA = DE.CDCIA INNER JOIN EQUIPAMENTO EQ ON EQ.CDEQUIP = PV.CDEQUIP INNER JOIN VOOTRECHO VT ON VT.CDFILIAL = DE.CDFILIAL AND VT.CDCIA = DE.CDCIA AND VT.NRVOO = DE.NRVOO AND VT.CDTRECHO = DE.CDTRECHO INNER JOIN BASE BO ON BO.CDBASE = VT.CDBASEORI INNER JOIN BASE BD ON BD.CDBASE = VT.CDBASEDES INNER JOIN VOO VO ON VO.CDFILIAL = DE.CDFILIAL AND VO.CDCIA = DE.CDCIA AND VO.NRVOO = DE.NRVOO INNER JOIN LISTA L ON L.NRLISTA = :P_NRLISTA AND DE.NRVOO || DE.CDTRECHO = L.CDLISTA WHERE(DE.CDFILIAL = :P_CDFILIAL) AND(DE.CDCIA = :P_CDCIA) AND (DE.DTEMISDEL BETWEEN :P_DTINI AND :P_DTFIN) AND (DE.IDDELIEXPSAP = '$exportIDDELIEXPSAP') AND (DE.IDSITDEL <> '3') AND (SE.IDSITSERSP <> '3') AND SCL.CDINTEGRASAP IS NULL");
		
		$stmt->execute(array(
			"P_NRLISTA" => $nrlista,
			"P_CDFILIAL" => $cdfilial,
			"P_CDCIA" => $cdcia,
			"P_DTINI" => $dtini,
			"P_DTFIN" => $dtfin
		));

		$result = $stmt->fetchAll(\PDO::FETCH_ASSOC);

		$dataError = array();

		for($i=0;$i<count($result);$i++) {
			array_push($dataError, $result[$i]['DATA_ERROR']);
		}

		return $dataError;

	}

	public function exportaDelivery (DTO\Request\DataSet $request, DTO\Response $response) {
		try {
			$this->connection->beginTransaction();
			
			$nrorg = $this->enviroment->getNrorgTrab();
			$nrlista = $this->newCode->getCodeByTableName('NRLISTA', $nrorg, 1, 10, false);
			
			$tvootrechoFlag = [];
			$deliveriesInvalidas = [];
			
			$rows = $request->getDataSet()->getRows();
			for($i = 0; $i < count($rows); $i++) {
				$row = $rows[$i];
				
				$row['NRORG'] = $nrorg;
				$tvootrecho = $row['TVOOTRECHO'] == "S";
				
				if ($tvootrecho) {
					$ciafiliKey = $row["CDFILIAL"].'-'.$row["CDCIA"];
					if (in_array($ciafiliKey, $tvootrechoFlag)) {
						continue;
					} else {
						array_push($tvootrechoFlag, $ciafiliKey);
					}
				}
				
				$this->exportacaoSAPService->insertLista($nrlista, $row, $tvootrecho, $response);

				$validaDelivery = $this->validaDelivery($nrlista, $row['CDFILIAL'], $row['CDCIA'], $row['DTINICIAL'], $row['DTFINAL'], $row['EXPORTNAME']);
				if ($validaDelivery) {
					$deliveriesInvalidas[] = $validaDelivery;
				}
			}
			
			$responseData = array( "NRLISTA" => $nrlista, "DATA_ERROR" => current($deliveriesInvalidas));
			$response->addDataset(new DataSet('dataset', $responseData));
			
			$this->connection->commit();
		} catch (\Exception $e) {
			$this->connection->rollback();
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
}