<?php
namespace Teknisa\COC\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class GeracaoCustoManual extends \Zeedhi\Framework\Controller\Report {
    protected $birtStrategy;

    public function __construct(ReportService $reportService, $birtStrategy) {
        parent::__construct($reportService);
        $this->birtStrategy = $birtStrategy;
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        if (isset($row['__locale']) && $row['__locale']){
          $this->birtStrategy->setReportLocale($row['__locale']);
        }
        $reportType = $row['REPORTTYPE'];
        $this->birtStrategy->setReportFormat($reportType);
    }

    protected $reportMapping = array (
        'COC23100' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
            	"CDFILIAL"	    => "CDFILIAL",
            	"CDMANCIA"      => "CDMANCIA",
            	"CDCIA"         => "CDCIA",
            	"SERVCLASSE"    => "SERVCLASSE",
            	"NRORG"         => "NRORG",
            	"TIPOCUSTO"     => "TIPOCUSTO",
            	"IDIOMA"        => "IDIOMA",
            	"CDINDICE"      => "CDINDICE",
            	"CDSUBGRU"      => "CDSUBGRU",
            	"DATACUSTO"     => "DATACUSTO",
            	"REPORTTYPE"    => "REPORTTYPE",
            	"ONLYVIGSBG"    => "ONLYVIGSBG",
            	"QTPAXREF"      => "QTPAXREF",
            	"CDCICLO"       => "CDCICLO",
                "NRITAIRVISION" => "NRITAIRVISION",
            	"INFLACAO"      => "INFLACAO"
            )
        ),
    );

}