<?php

namespace Teknisa\COC\Controllers;

use Teknisa\GER\Utilities\Environment;
use Teknisa\GER\Services\CrudService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\Remote\FileUploader\Server;

class MenuDesignController extends \Teknisa\GER\Controllers\TeknisaCrud {

	const MENU_GRID_DESENVOLVIMENTO = 'E';
	protected $fileUploader;
	protected $menuDesignService;
	protected $adService;
	protected $newCode;
	protected $crudService;
	protected $workflowService;
	protected $entityManager;
	protected $connection;

	protected $dataSourceManager;
	protected $dataSourceName = "coc03600_ciclosubgrusemam_ciclo_montasubsemam";
    protected $parameterBagColumns = array();
	protected $dataSourceNameToSave  = "ciclosubgrusemam";

	protected $fileserverPath;
	protected $pathKey;
	protected $undefinedImagePath;
	protected $dataSetErrosMenuGrid = array();

	public function __construct(CrudService $crudService, ParameterBag $parameterBag, Server $fileUploader, $fileServerParams, $entityManager, $menuDesignService, $adService, $newCode, $dataSourceManager, $workflowService) {
		$this->crudService = $crudService;
		$this->entityManager = $entityManager;
		$this->fileUploader = $fileUploader;
		$this->menuDesignService = $menuDesignService;
		$this->dataSourceManager = $dataSourceManager;
		$this->workflowService = $workflowService;
		$this->fileserverPath = $fileServerParams->getFileserverPath();
		$this->pathKey = $fileServerParams->getPathKey();
		$this->undefinedImagePath = $fileServerParams->getUndefinedImagePath();
		$this->adService = $adService;
		$this->newCode = $newCode;
		$this->connection = $this->entityManager->getConnection();
		parent::__construct($crudService, $parameterBag);
	}

	public function saveCiclo(DTO\Request $request, DTO\Response $response) {
		foreach ($request->getDataSet()->getRows() as $row) {
			if($row['__is_new']){

				$row['FGFOTOSUBSEMAM'] = NULL;
				$row['FGFOTOSUBSEMAMT'] = NULL;

				if(isset($row['PHOTO_UPLOAD'][0]))
					$row['FGFOTOSUBSEMAMT'] = $row['PHOTO_UPLOAD'][0]['path'];
				
				if(isset($row['PHOTO_UPLOAD_THUMBNAIL'][0]))
					$row['FGFOTOSUBSEMAM'] = $row['PHOTO_UPLOAD_THUMBNAIL'][0]['path'];				

			} else {
				
				//TRATAMENTO UPDATE
				if (isset($row['PHOTO_UPLOAD'][0])){
					//VERIFICA SE EXISTE IMAGEM ANTIGA PARA REMOVER DO FILESERVER
					$oldFiles = $this->menuDesignService->getOldFgfotosubsemam($row['CDCIA'], $row['CDFILIAL'], $row['CDCICLO'], $row['CDCLASSE'], $row['CDMANCIA'], $row['NRSERVICOCIAFILI'], $row['NRSEQSUBGRUSEMAM'], $row['NRORG']);
					
					$oldFgfotosubsemam = $oldFiles[0];

					if (($oldFgfotosubsemam) && ($oldFgfotosubsemam != null)){
						$this->menuDesignService->checkFileForDelete($oldFgfotosubsemam, $row['NRORG']);
					}					

					$row['FGFOTOSUBSEMAMT'] = $row['PHOTO_UPLOAD'][0]['path'];

				}
				
				if (isset($row['PHOTO_UPLOAD_THUMBNAIL'][0])){
					
					$oldFiles = $this->menuDesignService->getOldFgfotosubsemam($row['CDCIA'], $row['CDFILIAL'], $row['CDCICLO'], $row['CDCLASSE'], $row['CDMANCIA'], $row['NRSERVICOCIAFILI'], $row['NRSEQSUBGRUSEMAM'], $row['NRORG']);

					$oldFgfotosubsemamt = $oldFiles[1];

					if (($oldFgfotosubsemamt) && ($oldFgfotosubsemamt != NULL)){
						$this->menuDesignService->checkFileForDelete($oldFgfotosubsemamt, $row['NRORG']);
					}

					//INSERE NA ROW A NOVA IMAGEM
					$row['FGFOTOSUBSEMAM'] = $row['PHOTO_UPLOAD_THUMBNAIL'][0]['path'];

				} 
				
							
				if (!isset($row['FGFOTOSUBSEMAM']) || $row['FGFOTOSUBSEMAM'] == '') {
					//VERIFICA SE EXISTE IMAGEM ANTIGA PARA REMOVER DO FILESERVER
					$oldFiles = $this->menuDesignService->getOldFgfotosubsemam($row['CDCIA'], $row['CDFILIAL'], $row['CDCICLO'], $row['CDCLASSE'], $row['CDMANCIA'], $row['NRSERVICOCIAFILI'], $row['NRSEQSUBGRUSEMAM'], $row['NRORG']);
		
					$oldFgfotosubsemam = $oldFiles[0];
		
					if (($oldFgfotosubsemam) && ($oldFgfotosubsemam != NULL)){
						$this->menuDesignService->checkFileForDelete($oldFgfotosubsemam, $row['NRORG']);
					}
		
					$row['FGFOTOSUBSEMAM'] = NULL;
					$row['FGFOTOSUBSEMAMT'] = NULL;
		
				} else {	
					$row['FGFOTOSUBSEMAM'] = str_replace($this->fileserverPath, '', $row['FGFOTOSUBSEMAM']);
				}
				

			}

			
		}
		parent::save($request, $response);
	}

	public function geraCodigoLista(DTO\Request $request, DTO\Response $response) {
		$myCode = $this->newCode->getCodeByTableName('LISTA', $this->crudService->getEnvironment()->getNrOrg());
		$response->addDataSet(new DataSet("lista", [$myCode]));
	}

	public function deleteCiclo(DTO\Request $request, DTO\Response $response) {
		$row = $request->getRow();
		if ($row['FGFOTOSUBSEMAM']) {
			$row['FGFOTOSUBSEMAM'] = str_replace($this->fileserverPath, '', $row['FGFOTOSUBSEMAM']);
			$row['FGFOTOSUBSEMAMT'] = str_replace($this->fileserverPath, '', $row['FGFOTOSUBSEMAMT']);
			 if ($row['FGFOTOSUBSEMAM'] != NULL){
				$this->menuDesignService->checkFileForDelete($row['FGFOTOSUBSEMAM'], $row['NRORG']);
			}
			if ($row['FGFOTOSUBSEMAMT'] != NULL){
				$this->menuDesignService->checkFileForDelete($row['FGFOTOSUBSEMAMT'], $row['NRORG']);
			}
		}
		parent::delete($request, $response);
	}

	public function findCiclo(DTO\Request\Filter $request, DTO\Response $response) {
		$response2 = new DTO\Response();
		parent::find($request, $response2);
		if ($response2->getError()) {
			$response->setError($response2->getError());
		} else {
			$rows = array();
			foreach($response2->getDataSets()[0]->getRows() as $row) {
				$row['PHOTO_UPLOAD'] = [];
				$img = $row['FGFOTOSUBSEMAM'] ? $this->fileserverPath.$row['FGFOTOSUBSEMAM'] : 'UNDEFINED_IMAGE';
				$row['FGFOTOSUBSEMAM'] = $img;
				$rows[] = $row;
			}
			$response->addDataSet(new DataSet("ciclosubgrusemam_ciclo", $rows));
		}
	}

	public function findServ(DTO\Request\Filter $request, DTO\Response $response) {
		$this->parameterBagColumns = array("CDFILIAL", "NRORG", "CDMANCIA", "CDCIA");
		$this->dataSourceName = 'servmanualm_servicociafili_servicogen_classe';
		parent::find($request, $response);
	}

	public function loadDtsCrosstab(DTO\Request\Filter $request, DTO\Response $response) {
		$this->dataSourceName = 'view_aux_subgrupo';
		parent::find($request, $response);

		$data = Array();

		$dtsProdutocia = Array();
		$dtsCiclo = Array();
		$dtsCicloComp = Array();
        foreach ($response->getDataSets()[0]->getRows() as $row) {
			switch ($row['COLUNA']) {
				case 'SUBGRUPO':
					$custo = number_format($row["VRCUSTO"], 2, ',', '');
					array_push($data, Array(
						"SUBGRUPO"=> $row["SUBGRUPO"],
						"columnName"=> "SUBGRUPO",
						"columnLabel"=> "Subgrupo",
						"value"=> $row["SUBGRUPO"],
						"html"=> "<div class='sbg-cell'><div class='sbg-subgrupo'> <div> <span>".$row["DSSUBGRU"]."</span></div> <div>Custo: ".$custo."</div><div class='sbg-subgrupo-dtvig'> <span class='sbg-subgrupo-dtvig'>Vigência</span> <div>Início: ".$row["DTVIGINI"]."</div><div>Fim: ".$row["DTVIGFIM"]."</div></div></div></div></div>"
					));
					//array_push()
					break;

				case 'PROPORCAO':
					array_push($data, Array(
						"SUBGRUPO"=> $row["SUBGRUPO"],
						"columnName"=> "PROPORCAO",
						"columnLabel"=> "Proporção",
						"value"=> $row["PROPORCAO"],
						"html"=> "<div class='sbg-proporcao'>".$row["PROPORCAO"]."</div>"
					));
					break;

				case 'PRODUTOCIA':
					if (isset($dtsProdutocia[$row["SUBGRUPO"]])) {
						array_push($dtsProdutocia[$row["SUBGRUPO"]], $row);
					} else {
						$dtsProdutocia[$row["SUBGRUPO"]] = Array($row);
					}
					break;

				case 'CICLO':
					$dtsCiclo[$row["SUBGRUPO"]][$row["CDCICLO"]] = $row;
					break;

				case 'CICLOCOMP':
					if (isset($dtsCicloComp[$row["SUBGRUPO"]][$row["CDCICLO"]][$row["IDPRODREC"]])) {
						array_push($dtsCicloComp[$row["SUBGRUPO"]][$row["CDCICLO"]][$row["IDPRODREC"]], $row);
					} else {
						$dtsCicloComp[$row["SUBGRUPO"]][$row["CDCICLO"]][$row["IDPRODREC"]] = Array($row);
					}
					break;
			}
		}

		foreach ($dtsProdutocia as $subgrupo) {
			$html = "<div class='sbg-tabela'><div class='sbg-tabela-header'><span class='sbg-produtocia-col1'>Produto</span><span class='sbg-produtocia-col2'>Qtd.</span><span class='sbg-produtocia-col3'>UN</span></div>";
			foreach ($subgrupo as $row) {
				$qtd = ($row["SGUNIDADECIA"] == 'UN') ? $row["QTPRODUTOCIA"] : number_format($row["QTPRODUTOCIA"], 3, ',', '');
				$html = $html."<div><span class='sbg-produtocia-col1'>".$row["NMPRODUTOCIA"]."</span><span class='sbg-produtocia-col2'>".$qtd."</span><span class='sbg-produtocia-col3'>".$row["SGUNIDADECIA"]."</span></div>";
			}
			$html = $html."</div>";
			array_push($data, Array(
				"SUBGRUPO"=> $subgrupo[0]["SUBGRUPO"],
				"columnName"=> "PRODUTOCIA",
				"columnLabel"=> "Itens da Companhia",
				"value"=> "null",
				"html"=> $html
			));
		}

		$dataCiclos = array();
		foreach ($dtsCiclo as $subgrupo) {
			foreach ($subgrupo as $ciclo) {
				$img = $ciclo["FGFOTOSUBSEMAM"] ? $this->fileserverPath.$ciclo["FGFOTOSUBSEMAM"] : 'UNDEFINED_IMAGE';
				$html = "<div class='sbg-imagem'><img src='".$img."' height='150' width='200'></div>";
				if (!isset($dtsCicloComp[$ciclo['SUBGRUPO']][$ciclo['CDCICLO']])) {
				  $html = $html."<span class='sbg-msgcomp'>Ciclo sem composição</span>";
				} else {
                    $cicloComp = $dtsCicloComp[$ciclo['SUBGRUPO']][$ciclo['CDCICLO']];
                    foreach ($cicloComp as $prodrec) {
                        switch($prodrec[0]["IDPRODREC"]){
                            case 'PROD':
                                $header = 'Produto';
                                $complemento = "<span class='sbg-ciclotable-col2'>Qtd.</span><span class='sbg-ciclotable-col3'>UN</span><span class='sbg-ciclotable-col4'>Custo</span>";
                                break;
                            case 'REC':
                                $header = 'Receita';
                                $complemento = "<span class='sbg-ciclotable-col2'>Qtd.</span><span class='sbg-ciclotable-col3'>UN</span><span class='sbg-ciclotable-col4'>Custo</span>";
                                break;
                            case 'SEC':
                                $header = 'Subgrupo';
                                $complemento = "";
                                break;
                        }

						$html = $html . "<div class='sbg-tabela'><div class='sbg-tabela-header'><span class='sbg-ciclotable-col1'>" . $header . "</span>" . $complemento . "</div>";

                        foreach ($prodrec as $row) {
                            if($prodrec[0]["IDPRODREC"] !== 'SEC') {
                                if ($row["QTGRAMATURA"] && $row["QTGRAMATURA"] > 1) {
                                    $qtd = ($row["SGUNPRODRECCICLO"] == 'UN') ? $row["VRPESOGRAMATURA"] : number_format($row["VRPESOGRAMATURA"], 3, ',', '');
                                    $qtd = $row["QTGRAMATURA"] . 'x' . $qtd;
                                } else {
                                    $qtd = ($row["SGUNPRODRECCICLO"] == 'UN') ? $row["QTPRODRECCICLO"] : number_format($row["QTPRODRECCICLO"], 3, ',', '');
                                }
                                $custo = number_format(($row["VRCUSTO"]*$row["QTPRODRECCICLO"]), 2, ',', '');
                            } else{
                                $qtd = $custo = '';
                            }
                            
                            $condicao = !!$row["VRCUSTO"];
                            $condicaoRec = $row["SITUACAOREC"] == 'N';
                            
							$style = $condicaoRec ? ' class="coc-inactive"' : '';
							$styleCustoZero = $condicao ? 'coc-inactive' : 'coc-inactive';
                            $html = $html . "<div".$style."><span class='sbg-ciclotable-col1'>" . $row["NMPRODRECCICLO"] . "</span><span class='sbg-ciclotable-col2'>" . $qtd . "</span><span class='sbg-ciclotable-col3'>" . $row["SGUNPRODRECCICLO"] . "</span><span class='sbg-ciclotable-col4 ".$styleCustoZero."'>" . $custo . "</span></div>";
                        }

						$html = $html."</div><div class='sbg-ciclotable-space'></div>";
					}
				}
				array_push($dataCiclos, Array(
					"SUBGRUPO"=> $ciclo["SUBGRUPO"],
					"columnName"=> "CICLO".$ciclo["CDCICLO"],
					"columnLabel"=> "Ciclo ".$ciclo["IDCICLO"],
					"value"=> $ciclo["CDCICLO"],
					"html"=> $html,
					"NRORDEM" => $ciclo["NRORDEM"]
				));
			}
		}

		usort($dataCiclos, function($a, $b) {
			return strnatcmp($a['NRORDEM'], $b['NRORDEM']);
 		});

		foreach ($dataCiclos as $ciclo) {
			array_push($data, $ciclo);
		}

		$response->addDataSet(new DataSet("view_aux_subgrupo", $data));
	}

	public function verificaWorkflowPendenteMenuGrid($request, $response) {
		$row = $request->getRow();
		$qtd = $this->retornaQtdWorkflowPendenteMenuGrid($request, $row);
		$workflowPendente = $qtd > 0 ? true : false;
		$response->addDataSet(new DataSet('workflowPendente', array($workflowPendente)));
	}

	public function autenticarPorAd($request, $response) {
		try {
			$filter = $request->getFilterCriteria()->getConditions();
			$this->adService->login($filter[0]['value'], $filter[1]['value']);
			$response->addDataSet(new DataSet('userValid', array(true)));
		}catch(\Exception $e) {
			$response->setError(new Error($e->getMessage(), $e->getCode()));
		}
	}

	public function validaMenuGrid($request, $response) {
		try {
			$this->dataSetErrosMenuGrid = array();
			$menuGrid = $this->retornaMenuGrid($request);
			$this->validaDataMenuGrid($menuGrid);
			$this->validaWorkflowPendenteDoMenuGrid($request, $menuGrid);
			$response->addDataSet(new DataSet('errosMenuGrid', $this->dataSetErrosMenuGrid));
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), $e->getCode()));
		}
	}

	private function retornaQtdWorkflowPendenteMenuGrid($request, $menuGrid) {
		$conditions = $this->retornaCondicoesMenuGrid($menuGrid);
		$conditions[] = array(
			"columnName" => "NRPROCESSOAPROVA",
			"operator" => '=',
			"value" => 4
		);
		$requestWorkflowPendente = $this->montaRequest('dadoswf_workflow_pendento_menugrid', $conditions, $request);
		$this->dataSourceName = 'dadoswf_workflow_pendento_menugrid';
		$this->parameterBagColumns = array('NRPROCESSOAPROVA', 'CDMANCIA', 'CDCIA', 'CDFILIAL', 'NRORG');
		$rows = $this->retonaRows($requestWorkflowPendente);
		return intval($rows[0]['QTDE']);
	}

	public function validaWorkflowPendenteDoMenuGrid($request, $menuGrid) {
		$qtd = $this->retornaQtdWorkflowPendenteMenuGrid($request, $menuGrid);
		if ($qtd > 0)
			$this->insereMensagem("Este Menu Grid possui pendências no processo de Workflow.");
	}

	public function validaInformacoesDependentesMenuGrid($request, $response) {
		try {
			$this->dataSetErrosMenuGrid = array();
			$row = $request->getRow();
			$conditions = $this->retornaCondicoesMenuGrid($row);
			$conditions[] = array(
				'columnName' => 'IDVIGENCIA',
				'operator' => '=',
				'value' => 'T'
			);
			$conditions[] = array(
				'columnName' => 'IDSITUAPROPCIA',
				'operator' => '=',
				'value' => $row['IDSITUAPROPCIA']
			);
			$requestMenuGrid = $this->montaRequest('manualciam_operador_vigente', $conditions, $request);
			$menuGrid = $this->retornaMenuGrid($requestMenuGrid);
			$conditions = $this->retornaCondicoesMenuGrid($row);
			$requestServicosMenuGrid = $this->montaRequest('servmanualm_servicociafili_servicogen_classe', $conditions, $request);
			$servicosMenuGrid = $this->retornaServicosMenuGrid($requestServicosMenuGrid);

			$this->validaServicos($menuGrid, $servicosMenuGrid, $request);

			$this->validaDataMenuGrid($menuGrid);
			$response->addDataSet(new DataSet('errosMenuGrid', $this->dataSetErrosMenuGrid));
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), $e->getCode()));
		}
	}

	private function montaRequest($nome, $conditions, $request) {
		$filterCriteria = new FilterCriteria($nome, $conditions);
		return new DTO\Request\Filter($filterCriteria, $request->getMethod(),  $request->getRoutePath(), $request->getUserId());
	}

	private function retornaCondicoesMenuGrid($row) {
		return array(
			array(
				'columnName' => 'NRORG',
				'operator' => '=',
				'value' => $row['NRORG']
			),
			array(
				'columnName' => 'CDFILIAL',
				'operator' => '=',
				'value' => $row['CDFILIAL']
			),
			array(
				'columnName' => 'CDCIA',
				'operator' => '=',
				'value' => $row['CDCIA']
			),
			array(
				'columnName' => 'CDMANCIA',
				'operator' => '=',
				'value' => $row['CDMANCIA']
			),
		);
	}

	private function validaDataMenuGrid($menuGrid) {
		if (empty($menuGrid['DTINIVGMA']) || empty($menuGrid['DTFIMVGMA'])) {
			$this->insereMensagem("Data de Vigência do Menu Grid deve ser preenchida.");
		}
	}

	private function validaServicos($menuGrid, $servicos, $request) {
		if (count($servicos) > 0) {
			for ($i = 0; $i < sizeof($servicos); $i++) {

				// if (is_null($servicos[$i]['VRCUSTOSERVM'])) {
				// 	$this->insereMensagem("O custo do Serviço " . $servicos[$i]['DSSERVICOCIAFILI'] . " ainda não foi calculado.");
				// } else if($servicos[$i]['VRCUSTOSERVM'] == 0) {
				// 	$this->insereMensagem("O Serviço " . $servicos[$i]['DSSERVICOCIAFILI'] . " está com o custo zerado.");
				// }

				$subgrupos = $this->retornaSubGrupos($servicos[$i], $request);
				if (count($subgrupos) > 0) {
					$this->validaSubGrupos($menuGrid, $subgrupos, $request);
				} else {
					$this->insereMensagem("O Serviço " . $servicos[$i]['DSSERVICOCIAFILI'] . " não possui subgrupos.");
				}
			}
		} else {
			$this->insereMensagem("O Menu Grid não possui serviços.");
		}
	}

	private function validaSubGrupos($menuGrid, $subgrupos, $request) {
		$dataInicialMenuGrid = \DateTime::createFromFormat('d/m/Y H:i:s', $menuGrid['DTINIVGMA']);
		$dataFinalMenuGrid = \DateTime::createFromFormat('d/m/Y H:i:s', $menuGrid['DTFIMVGMA']);
		for ($i = 0; $i < sizeof($subgrupos); $i++) {

			if (is_null($subgrupos[$i]['DTHRAPROVACUSTO'])) {
				$this->insereMensagem("O custo do Subgrupo " . $subgrupos[$i]['DSSUBGRU'] . " ainda não foi aprovado.");
			}
			// else if ($subgrupos[$i]['VRCUSTO'] == 0){
			// 	$this->insereMensagem("O Subgrupo " . $subgrupos[$i]['DSSUBGRU'] . " está com o custo zerado.");
			// }

			if (!$subgrupos[$i]['DTINIVGSUMA'] || !$subgrupos[$i]['DTFIMVGSUMA']) {
				$this->insereMensagem("Data de Vigência do Subgrupo " . $subgrupos[$i]['DSSUBGRU'] . " deve ser preenchida.");
			} else if ($this->dataSubGrupoForaDataMenuGrid($subgrupos[$i], $dataInicialMenuGrid, $dataFinalMenuGrid)) {
				$this->insereMensagem("Data de Vigência do Subgrupo " . $subgrupos[$i]['DSSUBGRU'] . " fora do intervalo de vigência do Menu Grid (".$dataInicialMenuGrid->format('d/m/Y') . ' - ' . $dataFinalMenuGrid->format('d/m/Y') .")");
			} else {
				$this->validaDatasSubGruposIguais($subgrupos[$i], $subgrupos);
			}

			$this->validaProporcaoSubGrupo($subgrupos[$i], $request);
			$this->validaCicloSubGrupo($subgrupos[$i], $request);
		}
	}

	private function validaInstrucaoDeMontagemSubGrupo($ciclo, $subgrupo, $request) {
		$montasubsemam = $this->retornaMontasubsemam($ciclo, $request);
		if (count($montasubsemam) == 0 || empty($montasubsemam[0]['DSMONTASUBSEMAMHTML'])) {
			$this->insereMensagem("O Ciclo " . $ciclo['IDCICLO'] . " do Subgrupo " . $subgrupo['DSSUBGRU'] . " não possui instrução de montagem.");
		}
	}

	private function validaProporcaoSubGrupo($subgrupo, $request) {
		if (!$subgrupo['IDPROPSUBSEMAM']) {
			$this->insereMensagem("Campo de Proporção do Subgrupo" . $subgrupo['DSSUBGRU'] . " deve ser preenchida.");
		} else if ($subgrupo['IDPROPSUBSEMAM'] != "3" && (!isset($subgrupo['QTPROPSUBSEMAM']) || $subgrupo['QTPROPSUBSEMAM'] == "")) {
			$this->insereMensagem("Configuração do Subgrupo " . $subgrupo['DSSUBGRU'] . " deve ser preenchida.");
		} else if ($subgrupo['IDPROPSUBSEMAM'] == "3") {
			$propsubgruse = $this->retornaPropsubgruse($subgrupo, $request);
			if (count($propsubgruse) == 0) {
				$this->insereMensagem("Aba de Proporção Variável do SubGrupo " . $subgrupo['DSSUBGRU'] . " deve ser preenchida.");
			}
		}
	}

	private function validaCicloSubGrupo($subgrupo, $request) {
		$companhia = $this->retornaCompanhia($subgrupo, $request);
		$idutiairvision = $companhia[0]['IDUTIAIRVISION'];
		$ciclos = $this->retornaCiclos($subgrupo, $request);
		$itensCia = $this->retornaItensCia($subgrupo, $request);
		if (count($ciclos) > 0) {
			for ($i = 0; $i < sizeof($ciclos); $i++) {
				$this->validaIdutiairvision($idutiairvision, $ciclos[$i], $subgrupo);
				//$this->validaInstrucaoDeMontagemSubGrupo($ciclos[$i], $subgrupo, $request);

				// if (is_null($ciclos[$i]['VRCUSTOCICSEMAM'])) {
				// 	$this->insereMensagem("O custo do Ciclo " . $ciclos[$i]['IDCICLO'] . " do Subgrupo " . $subgrupo['DSSUBGRU'] . " ainda não foi calculado.");
				// } else if ($ciclos[$i]['VRCUSTOCICSEMAM'] == 0) {
				// 	$this->insereMensagem("O Ciclo " . $ciclos[$i]['IDCICLO'] . " do Subgrupo " . $subgrupo['DSSUBGRU'] . " está com o custo zerado.");
				// }
				$receitas = $this->retornaReceitas($ciclos[$i], $request);
				$produtos = $this->retornaProdutos($ciclos[$i], $request);

				if (count($receitas) == 0 && count($produtos) == 0) {
					//27/07 - Nova validação solicitada, caso não exista composição para o Subgrupo
					//valida se existem Itens da Companhia para o mesmo antes de bloquear o processo.
					if(count($itensCia) == 0){
						$this->insereMensagem("O Ciclo " . $ciclos[$i]['IDCICLO'] . " do Subgrupo " . $subgrupo['DSSUBGRU']. " do Serviço ".$subgrupo['DSSERVICOCIAFILI'] . " não possui Composição ou Itens da Companhia.");
					}
				}

				if (count($receitas) > 0) {
					$this->validaReceitasCiclo($receitas, $subgrupo, $ciclos[$i], $request);
				}

				if (count($produtos) > 0) {
					$this->validaProdutosCiclo($produtos, $subgrupo, $ciclos[$i], $request);
				}
			}
		} else {
			$this->insereMensagem("O SubGrupo " . $subgrupo['DSSUBGRU'] . " não possui ciclos.");
		}
	}

	private function validaReceitasCiclo($receitas, $subgrupo, $ciclo, $request) {
        $codigoDasReceitas = array();
        for ($i = 0; $i < sizeof($receitas); $i++) {
            $codigoDasReceitas[] = $receitas[$i]['CDRECEITA'];

            if (is_null($receitas[$i]['VRCUSRESUBSEMAM'])) {
				$this->insereMensagem("O custo da Receita " . $receitas[$i]['DSRECEITA'] . " do Ciclo " . $ciclo['IDCICLO'] . " do Subgrupo " . $subgrupo['DSSUBGRU'] . " ainda não foi calculado.");
      	    } else if ($receitas[$i]['VRCUSRESUBSEMAM'] == 0) {
				$this->insereMensagem("A Receita " . $receitas[$i]['DSRECEITA'] . " do Ciclo " . $ciclo['IDCICLO'] . " do Subgrupo " . $subgrupo['DSSUBGRU']. " do Serviço ".$subgrupo['DSSERVICOCIAFILI'] . " está com o custo zerado.");
      	    }
        }
        $params = array("CDRECEITA" => implode('_', $codigoDasReceitas));
        $stmt = $this->entityManager->getConnection()->prepare("SELECT * FROM RECEITAM WHERE (INSTR(:CDRECEITA, CDRECEITA) <> 0) AND IDATIVO = 'N'");
        $stmt->execute($params);
        $result = $stmt->fetchAll();
        for($j=0;$j<count($result);$j++){
                $this->insereMensagem("A Receita " . $result[$j]['DSRECEITA'] . " do Ciclo " . $ciclo['IDCICLO'] . " do Subgrupo " . $subgrupo['DSSUBGRU']. " do Serviço ".$subgrupo['DSSERVICOCIAFILI']. " está inativa.");
        }
	}

	private function validaProdutosCiclo($produtos, $subgrupo, $ciclo, $request) {
      	$codigoDosProdutos = array();
      	for ($i = 0; $i < sizeof($produtos); $i++) {
      		$codigoDosProdutos[] = $produtos[$i]['CDPRODUTO'];

      	    if (is_null($produtos[$i]['VRCUSPRSUBSEMAM'])) {
				$this->insereMensagem("O custo do Produto " . $produtos[$i]['NMPRODUTO'] . " do Ciclo " . $ciclo['IDCICLO'] . " do Subgrupo " . $subgrupo['DSSUBGRU']. " do Serviço ".$subgrupo['DSSERVICOCIAFILI']." ainda não foi calculado.");
      	    }
    //else if ($produtos[$i]['VRCUSPRSUBSEMAM'] == 0) {
				// $this->insereMensagem("O Produto " . $produtos[$i]['NMPRODUTO'] . " do Ciclo " . $ciclo['IDCICLO'] . " do Subgrupo " . $subgrupo['DSSUBGRU'] . " está com o custo zerado.");
    //   	    }
      	}
      	$params = array("CDPRODUTO" => implode('_', $codigoDosProdutos));
      	$stmt = $this->entityManager->getConnection()->prepare("SELECT * FROM PRODUTO WHERE (INSTR(:CDPRODUTO, CDPRODUTO) <> 0) AND IDPRODATIVPR = 'N' ");
      	$stmt->execute($params);
      	$result = $stmt->fetchAll();
      	for($j=0;$j<count($result);$j++) {
      	    $this->insereMensagem("O Produto ". $result[$j]['NMPRODUTO'] . " do Ciclo " . $ciclo['IDCICLO'] . " do Subgrupo " . $subgrupo['DSSUBGRU']. " do Serviço ".$subgrupo['DSSERVICOCIAFILI']. " está inativo.");
      	}
	}


	private function validaIdutiairvision($idutiairvision, $ciclo, $subgrupo) {
		if ($idutiairvision == 'S') {
			if (!$ciclo['NRITAIRVISION']) {
				$this->insereMensagem("O campo IT do Ciclo " . $ciclo['IDCICLO'] . " do Subgrupo " . $subgrupo['DSSUBGRU'] . " deve ser preenchido.");
			}
		}
	}

	private function insereMensagem($mensagem) {
		if (!in_array($mensagem, $this->dataSetErrosMenuGrid)) {
			$this->dataSetErrosMenuGrid[] = $mensagem;
		}
	}

	private function validaDatasSubGruposIguais($subgrupo, $subgrupos) {
		for ($i = 0; $i < sizeof($subgrupos); $i++) {
			if ($subgrupo['NRSEQSUBGRUSEMAM'] != $subgrupos[$i]['NRSEQSUBGRUSEMAM'] && $subgrupo['CDSUBGRU'] == $subgrupos[$i]['CDSUBGRU']) {
				if ($this->dataSubGrupoInvalida($subgrupo, $subgrupos[$i])) {
					$mensagem = "Datas de Vigência dos Subgrupos " . $subgrupo['DSSUBGRU'] . " estão em conflito.";
					$this->insereMensagem($mensagem);
				}
			}
		}
	}

	private function dataSubGrupoInvalida($subgrupo, $currentSubgrupo) {
		$dataInicialSubGrupo = \DateTime::createFromFormat('d/m/Y H:i:s', $subgrupo['DTINIVGSUMA']);
		$dataFinalSubGrupo = \DateTime::createFromFormat('d/m/Y H:i:s', $subgrupo['DTFIMVGSUMA']);

		$dataInicialCurrentSubGrupo = \DateTime::createFromFormat('d/m/Y H:i:s', $currentSubgrupo['DTINIVGSUMA']);
		$dataFinalCurrentSubGrupo = \DateTime::createFromFormat('d/m/Y H:i:s', $currentSubgrupo['DTFIMVGSUMA']);

		$comparaDataInicialSubGrupo = $dataInicialSubGrupo >= $dataInicialCurrentSubGrupo && $dataInicialSubGrupo <= $dataFinalCurrentSubGrupo;
		$comparaDataFinalSubGrupo = $dataFinalSubGrupo >= $dataInicialCurrentSubGrupo && $dataFinalSubGrupo <= $dataFinalCurrentSubGrupo;

		return $comparaDataInicialSubGrupo || $comparaDataFinalSubGrupo;
	}

	private function dataSubGrupoForaDataMenuGrid($subgrupo, $dataInicialMenuGrid, $dataFinalMenuGrid) {
		$dataInicialSubGrupo = \DateTime::createFromFormat('d/m/Y H:i:s', $subgrupo['DTINIVGSUMA']);
		$dataFinalSubGrupo = \DateTime::createFromFormat('d/m/Y H:i:s', $subgrupo['DTFIMVGSUMA']);

		$comparaDataInicialSubGrupo = $dataInicialSubGrupo < $dataInicialMenuGrid || $dataInicialSubGrupo > $dataFinalMenuGrid;
		$comparaDataFinalSubGrupo = $dataFinalSubGrupo < $dataInicialMenuGrid || $dataFinalSubGrupo > $dataFinalMenuGrid;

		return $comparaDataInicialSubGrupo || $comparaDataFinalSubGrupo;
	}

	private function retornaMenuGrid($request) {
		$this->dataSourceName = 'manualciam_operador_vigente';
		$this->parameterBagColumns = array('NRORG', 'CDFILIAL', 'CDCIA', 'IDVIGENCIA', 'IDSITUAPROPCIA');

		$filterCriteria = $request->getFilterCriteria();
		$filterCriteria->addCondition('IDVIGENCIA', 'T');

        $filterCriteria->setDataSourceName($this->dataSourceName);
        $filterCriteria = $this->crudService->getFilterCriteriaWithNrOrg($filterCriteria);
        $newFilterCriteria = $this->crudService->getPopulatedFilterCriteria($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        return $dataSet->getRows()[0];
	}

	private function retornaServicosMenuGrid($request) {
		$this->dataSourceName = 'servmanualm_servicociafili_servicogen_classe';
		$this->parameterBagColumns = array('NRORG', 'CDFILIAL', 'CDCIA', 'CDMANCIA');

		return $this->retonaRows($request);
	}

	private function retornaSubGrupos($servico, $request) {
		$conditions = $this->retornaCondicoesMenuGrid($servico);
		$conditions = $this->adicionaCondicoesSubGrupo($conditions, $servico);
		$request = $this->montaRequest('subgrusemam_subgrupom', $conditions, $request);
		$this->dataSourceName = 'subgrusemam_subgrupom';
		$this->parameterBagColumns = array();

		return $this->retonaRows($request);
	}

	private function retornaPropsubgruse($subgrupo, $request) {
		$conditions = $this->retornaCondicoesMenuGrid($subgrupo);
		$conditions = $this->adicionaCondicoesSubGrupo($conditions, $subgrupo);
		$conditions = $this->adicionaCondicoesPropsubgruse($conditions, $subgrupo);
		$request = $this->montaRequest('propsubgruse', $conditions, $request);
		$this->dataSourceName = 'propsubgruse';
		$this->parameterBagColumns = array();

		return $this->retonaRows($request);
	}

	private function retornaCompanhia($subgrupo, $request) {
		$conditions = $this->retornaCondicoesCompanhia($subgrupo);
		$request = $this->montaRequest('companhia', $conditions, $request);
		$this->dataSourceName = 'companhia';
		$this->parameterBagColumns = array();

		return $this->retonaRows($request);
	}

	private function retornaCiclos($subgrupo, $request) {
		$conditions = $this->retornaCondicoesMenuGrid($subgrupo);
		$conditions = $this->adicionaCondicoesSubGrupo($conditions, $subgrupo);
		$conditions = $this->adicionaCondicoesPropsubgruse($conditions, $subgrupo);
		$request = $this->montaRequest('ciclosubgrusemam_ciclo', $conditions, $request);
		$this->dataSourceName = 'ciclosubgrusemam_ciclo';
		$this->parameterBagColumns = array();

		return $this->retonaRows($request);
	}

	private function retornaItensCia($ciclo, $request) {
		$conditions = $this->retornaCondicoesMenuGrid($ciclo);
		$conditions = $this->adicionaCondicoesSubGrupo($conditions, $ciclo);
		$conditions = $this->adicionaCondicoesPropsubgruse($conditions, $ciclo);
		$request = $this->montaRequest('prociasubsemam', $conditions, $request);
		$this->dataSourceName = 'prociasubsemam';
		$this->parameterBagColumns = array('NRSEQSUBGRUSEMAM', 'CDSUBGRU', 'CDCLASSE', 'NRSERVICOCIAFILI', 'CDMANCIA', 'NRORG', 'CDCIA', 'CDFILIAL');
		return $this->retonaRows($request);
	}

	private function retornaMontasubsemam($ciclo, $request) {
		$conditions = $this->retornaCondicoesMenuGrid($ciclo);
		$conditions = $this->adicionaCondicoesSubGrupo($conditions, $ciclo);
		$conditions = $this->adicionaCondicoesPropsubgruse($conditions, $ciclo);
		$conditions = $this->adicionaCondicoesProdutoReceita($conditions, $ciclo);
		$request = $this->montaRequest('montasubsemam', $conditions, $request);
		$this->dataSourceName = 'montasubsemam';
		$this->parameterBagColumns = array();

		return $this->retonaRows($request);
	}

	private function retornaProdutos($ciclo, $request) {
		$conditions = $this->retornaCondicoesMenuGrid($ciclo);
		$conditions = $this->adicionaCondicoesSubGrupo($conditions, $ciclo);
		$conditions = $this->adicionaCondicoesPropsubgruse($conditions, $ciclo);
		$conditions = $this->adicionaCondicoesProdutoReceita($conditions, $ciclo);
		$request = $this->montaRequest('prodsubsemam_produto', $conditions, $request);
		$this->dataSourceName = 'prodsubsemam_produto';
		$this->parameterBagColumns = array('NRSEQSUBGRUSEMAM', 'CDSUBGRU', 'CDCICLO', 'CDCLASSE', 'NRSERVICOCIAFILI', 'CDMANCIA', 'NRORG', 'CDCIA', 'CDFILIAL');

		return $this->retonaRows($request);
	}

	private function retornaReceitas($ciclo, $request) {
		$conditions = $this->retornaCondicoesMenuGrid($ciclo);
		$conditions = $this->adicionaCondicoesSubGrupo($conditions, $ciclo);
		$conditions = $this->adicionaCondicoesPropsubgruse($conditions, $ciclo);
		$conditions = $this->adicionaCondicoesProdutoReceita($conditions, $ciclo);
		$request = $this->montaRequest('recsubsemam_receita', $conditions, $request);
		$this->dataSourceName = 'recsubsemam_receita';
		$this->parameterBagColumns = array('NRSEQSUBGRUSEMAM', 'CDSUBGRU', 'CDCICLO', 'CDCLASSE', 'NRSERVICOCIAFILI', 'CDMANCIA', 'NRORG', 'CDCIA', 'CDFILIAL');

		return $this->retonaRows($request);
	}



	private function retornaReceitaCadastrada($receita, $request) {
		$conditions = $this->retornaCondicoesReceitaProduto($receita, "CDRECEITA");
		$request = $this->montaRequest('receitam', $conditions, $request);
		$this->dataSourceName = 'receitam';
		$this->parameterBagColumns = array();

		return $this->retonaRows($request);
	}

	private function retornaProdutoCadastrado($produto, $request) {
		$conditions = $this->retornaCondicoesReceitaProduto($produto, "CDPRODUTO");
		$request = $this->montaRequest('produto', $conditions, $request);
		$this->dataSourceName = 'produto';
		$this->parameterBagColumns = array();

		return $this->retonaRows($request);
	}

	private function adicionaCondicoesSubGrupo($conditions, $servico) {
		$conditions[] = array(
			'columnName' => 'NRSERVICOCIAFILI',
			'operator' => '=',
			'value' => $servico['NRSERVICOCIAFILI']
		);
		$conditions[] = array(
			'columnName' => 'CDCLASSE',
			'operator' => '=',
			'value' => $servico['CDCLASSE']
		);
		return $conditions;
	}

	private function adicionaCondicoesPropsubgruse($conditions, $subgrupo) {
		$conditions[] = array(
			'columnName' => 'CDSUBGRU',
			'operator' => '=',
			'value' => $subgrupo['CDSUBGRU']
		);
		$conditions[] = array(
			'columnName' => 'NRSEQSUBGRUSEMAM',
			'operator' => '=',
			'value' => $subgrupo['NRSEQSUBGRUSEMAM']
		);
		return $conditions;
	}

	private function adicionaCondicoesProdutoReceita($conditions, $ciclo) {
		$conditions[] = array(
			'columnName' => 'CDCICLO',
			'operator' => '=',
			'value' => $ciclo['CDCICLO']
		);
		return $conditions;
	}

	private function retornaCondicoesCompanhia($subgrupo) {
		return array(
			array(
				'columnName' => 'CDCIA',
				'operator' => '=',
				'value' => $subgrupo['CDCIA']
			),
			array(
				'columnName' => 'NRORG',
				'operator' => '=',
				'value' => $subgrupo['NRORG']
			)
		);
	}

	private function retornaCondicoesReceitaProduto($receitaProduto, $posicao) {
		return array(
			array(
				'columnName' => $posicao,
				'operator' => '=',
				'value' => $receitaProduto[$posicao]
			),
			array(
				'columnName' => 'NRORG',
				'operator' => '=',
				'value' => $receitaProduto['NRORG']
			)
		);
	}

	private function retonaRows($request) {
		$filterCriteria = $request->getFilterCriteria();
        $filterCriteria->setDataSourceName($this->dataSourceName);
        $filterCriteria = $this->crudService->getFilterCriteriaWithNrOrg($filterCriteria);
        $newFilterCriteria = $this->crudService->getPopulatedFilterCriteria($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        return $dataSet->getRows();
	}

	public function salvaWorkflow($request, $response) {
		try {
			$row = $request->getRow();
			$primaryKeys = $row['PRIMARYKEYS'];
			$dsmotivowflow = $row['DSMOTIVOACAO'];
			$nmitemwflow = $row['NMITEM'];
			$nmtabelawflow = $row['NMTABELA'];
			$idtipoperwflow = $row['IDTIPOPERWFLOW'];
			$nrprocessoaprova = $row['NRPROCESSOAPROVA'];
			$nritemprocaprova = $row['NRITEMPROCAPROVA'];
			$workflowRow = $this->workflowService->createRowToWorkFlowProcess($row['CHANGEDITEMS'], $primaryKeys, $dsmotivowflow, $nmitemwflow, $nmtabelawflow, $idtipoperwflow, $nritemprocaprova, $nrprocessoaprova);
			$this->workflowService->createWorkFlowProcess($primaryKeys, $row['CHANGEDITEMS'], $workflowRow/*, true, 'IDANALIZEATIV'*/);
			$response->addMessage(new Message('WorkFlow criado com sucesso. Aguarde aprovação'));
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), $e->getCode()));
		}
	}

	public function tryDeleteWithTransaction($request, $response) {
		$row = (array)$request->getRow();
		$sql = "DELETE FROM SERVMANUALM
				WHERE CDFILIAL = :CDFILIAL
					AND CDCIA = :CDCIA
					AND CDMANCIA = :CDMANCIA
					AND NRSERVICOCIAFILI = :NRSERVICOCIAFILI
					AND CDCLASSE = :CDCLASSE
					AND NRORG = :NRORG";
		$params = array(
			'CDFILIAL' => $row['CDFILIAL'],
			'CDCIA' => $row['CDCIA'],
			'CDMANCIA' => $row['CDMANCIA'],
			'NRSERVICOCIAFILI' => $row['NRSERVICOCIAFILI'],
			'CDCLASSE' => $row['CDCLASSE'],
			'NRORG' => $row['NRORG']
		);

		$this->tryExecute($sql, $params, $response);
	}

	public function insertServicoWF($request, $response){
		$rows = $request->getDataSet()->getRows();
		$messageError = array();
		foreach($rows as $pos => $dataWf){
			$conditionsServmanualm = $this->getConditionsByServmanualm($dataWf['PRIMARYKEYS']);
			$paramBagColumns = array('CDFILIAL','CDCIA','CDMANCIA','NRORG');
			$dataSetServmanualm = $this->findWithParameterBag('servmanualm_servicociafili_servicogen_classe', $conditionsServmanualm, $paramBagColumns);
			if(!empty($dataSetServmanualm)){
				$messageError[] = 'Registro existente: Serviço: ('.$dataSetServmanualm[0]['DSSERVICOCIAFILI'].') - Classe: ('.$dataSetServmanualm[0]['DSCLASSE'].')';
			}

			$qtde = $this->findDadosWF($dataWf, '1', '2');
			if($qtde > 0){
				$messageError[] = 'Já existe um processo de Workflow para: '.$dataWf['NMITEM'];
			}
			if(empty($dataSetServmanualm) && $qtde == 0) {
				$requestWf = $this->createRequestToWf($dataWf);
				$this->salvaWorkflow($requestWf, $response);
			}
		}
		$errorDataSet = new DataSet('errors', $messageError);
		$response->addDataSet($errorDataSet);
	}

	private function createRequestToWf($row){
		$dataSourceRow = new DTO\Request\Row($row, '','','');
		return $dataSourceRow;
	}

	private function findDadosWF($dataWF, $IDSITWORKFLOW, $IDTIPOPERWFLOW){
		$pkConcat = $this->workflowService->rowToStr($dataWF['PRIMARYKEYS']);
		$conditions = array(
			array(
				'columnName' => 'NRPROCESSOAPROVA',
				'operator' => '=',
				'value' => $dataWF['NRPROCESSOAPROVA']
			),
			array(
				'columnName' => 'IDSITWORKFLOW',
				'operator' => '=',
				'value' => strval($IDSITWORKFLOW)
			),
			array(
				'columnName' => 'NRITEMPROCAPROVA',
				'operator' => '=',
				'value' => '_'.$dataWF['NRITEMPROCAPROVA'].'_'
			),
			array(
				'columnName' => 'IDTIPOPERWFLOW',
				'operator' => '=',
				'value' => '_'.$IDTIPOPERWFLOW.'_'
			),
			array(
				'columnName' => 'DSPRIMARYKEY',
				'operator' => '=',
				'value' => $pkConcat
			),
			array(
				'columnName' => 'NRORG',
				'operator' => '=',
				'value' => $dataWF['PRIMARYKEYS']['NRORG']
			)
		);
		$filterCriteria = new FilterCriteria('quantidade_workflow', $conditions);
        $parameterBagColumns = array('NRPROCESSOAPROVA','IDSITWORKFLOW','NRITEMPROCAPROVA','IDTIPOPERWFLOW','DSPRIMARYKEY','NRORG');
        $filterCriteria = $this->crudService->getFilterCriteriaWithNrOrg($filterCriteria);
        $newFilterCriteria = $this->crudService->getPopulatedFilterCriteria($filterCriteria, $parameterBagColumns);
        $dataset = $this->dataSourceManager->findBy($newFilterCriteria)->getRows();
        return $dataset[0]['QTD_WFLOW'];
	}

	private function getConditionsByServmanualm($row){
		$conditions = array(
			array(
				'columnName' => 'CDFILIAL',
				'operator' => '=',
				'value' => $row['CDFILIAL']
			),
			array(
				'columnName' => 'CDCIA',
				'operator' => '=',
				'value' => $row['CDCIA']
			),
			array(
				'columnName' => 'CDMANCIA',
				'operator' => '=',
				'value' => $row['CDMANCIA']
			),
			array(
				'columnName' => 'NRSERVICOCIAFILI',
				'operator' => '=',
				'value' => $row['NRSERVICOCIAFILI']
			),
			array(
				'columnName' => 'CDCLASSE',
				'operator' => '=',
				'value' => $row['CDCLASSE']
			),
			array(
				'columnName' => 'NRORG',
				'operator' => '=',
				'value' => $row['NRORG']
			)
		);
		return $conditions;
	}

	private function findWithParameterBag($dataSourceName, $conditions, array $parameterBagColumns){

		$filterCriteria = new FilterCriteria($dataSourceName, $conditions);
        $filterCriteria = $this->crudService->getFilterCriteriaWithNrOrg($filterCriteria);
        $newFilterCriteria = $this->crudService->getPopulatedFilterCriteria($filterCriteria,$parameterBagColumns);
        $dataset = $this->dataSourceManager->findBy($newFilterCriteria)->getRows();
        return $dataset;
	}

	private function tryExecute($sql, $params, &$response){
		$connection = $this->entityManager->getConnection();
		$connection->beginTransaction();
		$query = $connection->prepare($sql);
		try {
    		$result = $query->execute($params);
		} catch(\Exception $e){
			$response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
		}
		$connection->rollback();
	}

	private function getConditionsBySubgrupo($row){
		$conditions = array(
			array(
				'columnName' => 'CDSUBGRU',
				'operator' => '=',
				'value' => $row['CDSUBGRU']
			),
			array(
				'columnName' => 'CDCLASSE',
				'operator' => '=',
				'value' => $row['CDCLASSE']
			),
			array(
				'columnName' => 'NRSERVICOCIAFILI',
				'operator' => '=',
				'value' => $row['NRSERVICOCIAFILI']
			),
			array(
				'columnName' => 'CDMANCIA',
				'operator' => '=',
				'value' => $row['CDMANCIA']
			),
			array(
				'columnName' => 'CDCIA',
				'operator' => '=',
				'value' => $row['CDCIA']
			),
			array(
				'columnName' => 'CDFILIAL',
				'operator' => '=',
				'value' => $row['CDFILIAL']
			),
			array(
				'columnName' => 'NRORG',
				'operator' => '=',
				'value' => $row['NRORG']
			)
		);
		return $conditions;
	}

	public function insertSubgrupoWF($request, $response){
		$row = (array)$request->getRow();
		$conditionsSubgrupo = $this->getConditionsBySubgrupo($row['PRIMARYKEYS']);
		$paramBagColumns = array();
		$dataSetSubgrupo = $this->findWithParameterBag('subgrusemam_subgrupom', $conditionsSubgrupo, $paramBagColumns);
		$qtde = $this->findDadosWF($row, '1', '2');
		try{
			if(!empty($dataSetSubgrupo)){
				throw new \Exception('Impossível adicionar. Subgrupo já cadastrado neste serviço.');
			}

			if($qtde > 0){
				throw new \Exception('Este dado já está em processo de workflow');
			}
			if(empty($dataSetSubgrupo) && $qtde == 0) {
				$novoSequencial = $this->newCode->getCodeByTableName('SUBGRUSEMAM', $this->crudService->getEnvironment()->getNrOrg(), 1, 20, true);
				$row['PRIMARYKEYS']['NRSEQSUBGRUSEMAM'] = $novoSequencial;
				$requestWf = $this->createRequestToWf($row);
				$this->salvaWorkflow($requestWf, $response);
			}
		} catch (\Exception $e){
			$response->setError(new Error($e->getMessage(), 1));
		}
	}

	public function subgrupoDeleteWf($request, $response){
		$row = (array)$request->getRow();
		$pk = $row['PRIMARYKEYS'];
		$sql = "DELETE FROM SUBGRUSEMAM
				WHERE CDFILIAL = :CDFILIAL
					AND CDCIA = :CDCIA
					AND CDMANCIA = :CDMANCIA
					AND NRSERVICOCIAFILI = :NRSERVICOCIAFILI
					AND CDCLASSE = :CDCLASSE
					AND NRORG = :NRORG
					AND NRSEQSUBGRUSEMAM = :NRSEQSUBGRUSEMAM
					AND CDSUBGRU = :CDSUBGRU";
		$params = array(
			'CDFILIAL' => $pk['CDFILIAL'],
			'CDCIA' => $pk['CDCIA'],
			'CDMANCIA' => $pk['CDMANCIA'],
			'NRSERVICOCIAFILI' => $pk['NRSERVICOCIAFILI'],
			'CDCLASSE' => $pk['CDCLASSE'],
			'NRSEQSUBGRUSEMAM' => $pk['NRSEQSUBGRUSEMAM'],
			'CDSUBGRU' => $pk['CDSUBGRU'],
			'NRORG' => $pk['NRORG']
		);

		$this->tryExecute($sql, $params, $response);
		if($response->getStatus() != 'E'){
			$this->salvaWorkflow($request, $response);
		}
	}

	private function criaPropriedadePodeAlterar($tipo, &$dataset, $request) {
		if (sizeof($dataset) > 0) {
			foreach ($dataset as &$row) {
				$conditions = $this->retornaCondicoesReceitaProdutoPendente($tipo, $row);
				$request = $this->montaRequest($this->dataSourceName, $conditions, $request);
				$rowsPendentes = $this->retonaRows($request);
				if ($rowsPendentes[0]['QTD_WFLOW'] > 0) {
					$row['PODE_ALTERAR'] = false;
					if (isset($row['changed_QTD'])) {
						$row['QTD'] = $row['changed_QTD'];
						unset($row['changed_QTD']);
						unset($row['QTD_inline']);
					}
				} else {
					$row['PODE_ALTERAR'] = true;
				}
			}
		}
	}

	public function verificaWorkflowPendenteReceitaProduto($request, $response) {
		try {
			$this->dataSourceName = 'quantidade_workflow';
			$this->parameterBagColumns = array('NRPROCESSOAPROVA', 'IDSITWORKFLOW', 'IDTIPOPERWFLOW', 'DSPRIMARYKEY', 'NRORG', 'NRITEMPROCAPROVA', 'NRITEMPROCAPROVA');
			$dataset = $request->getDataSet()->getRows();
			$produtos = (array)$dataset[0];
			$receitas = (array)$dataset[1];
			$this->criaPropriedadePodeAlterar('PRODUTO', $produtos, $request);
			$this->criaPropriedadePodeAlterar('RECEITA', $receitas, $request);
			$responseArray = array(
				'produtos' => $produtos,
				'receitas' => $receitas,
				'usaWorkFlow' => array(
					"receita" => $this->retornaUsaWorkflow('21', $request),
					"produto" => $this->retornaUsaWorkflow('18', $request),
				)
			);
    		$response->addDataSet(new DataSet('response', $responseArray));
		} catch(\Exception $e){
			$response->setError(new Error($e->getMessage(), $e->getCode()));
		}
	}

	private function retornaCondicoesReceitaProdutoPendente($tipo, $receitaProduto) {
		$conditions = array(
			array(
				'columnName' => 'NRPROCESSOAPROVA',
				'operator' => '=',
				'value' => '4' // Menu Grid
			),
			array(
				'columnName' => 'IDSITWORKFLOW',
				'operator' => '=',
				'value' => '1' // Pendente
			),
			array(
				'columnName' => 'IDTIPOPERWFLOW',
				'operator' => '=',
				'value' => 'T' // Update, Insert, Delete
			),
			array(
				'columnName' => 'DSPRIMARYKEY',
				'operator' => '=',
				'value' => $receitaProduto['PKS']
			),
			array(
				'columnName' => 'NRORG',
				'operator' => '=',
				'value' => $receitaProduto['NRORG']
			)
		);
		if ($tipo == 'PRODUTO') {
			$conditions[] = array(
				'columnName' => 'NRITEMPROCAPROVA',
				'operator' => '=',
				'value' => '_16_17_18_' // Alteração, inclusão e exclusão de produto
			);
		}
		if ($tipo == 'RECEITA') {
			$conditions[] = array(
				'columnName' => 'NRITEMPROCAPROVA',
				'operator' => '=',
				'value' => '_19_20_21_' // Alteração, inclusão e exclusão de receita
			);
		}
		return $conditions;
	}

	private function retornaUsaWorkflow($NRITEMPROCAPROVA, $request) {
		$this->dataSourceName = 'processos_workflow';
		$this->parameterBagColumns = array('NRPROCESSOAPROVA', 'NRITEMPROCAPROVA');
		$conditions = array(
			array(
				'columnName' => 'NRPROCESSOAPROVA',
				'operator' => '=',
				'value' => '4' // Menu Grid
			),
			array(
				'columnName' => 'NRITEMPROCAPROVA',
				'operator' => '=',
				'value' => $NRITEMPROCAPROVA
			)
		);
		$request = $this->montaRequest($this->dataSourceName, $conditions, $request);
		$rows = $this->retonaRows($request);
		if (count($rows) > 0 	&& $rows[0]['IDATIVO'] == 'S')
			return true;
		else
			return false;
	}

	public function validateTornarProposta($request,$response) {
		try{
			$messages = array();
			$row = (array)$request->getRow();
			$connection = $this->entityManager->getConnection();
			$environment = $this->crudService->getEnvironment();
			$conditions = array(
				array(
					'columnName' => 'CDFILIAL',
					'operator' => '=',
					'value' => $row['CDFILIAL']
				),
				array(
					'columnName' => 'CDCIA',
					'operator' => '=',
					'value' => $row['CDCIA']
				),
				array(
					'columnName' => 'CDMANCIA',
					'operator' => '=',
					'value' => $row['CDMANCIA']
				),
					array(
					'columnName' => 'NRORG',
					'operator' => '=',
					'value' => $environment->getNrOrg()
				)
			);
			$servicos = $this->crudService->getFilteredDataSet('servmanualm_servicociafili_classe',$conditions)->getRows();
			if(empty($servicos)) {
				array_push($messages,'Não é possível tornar proposta um menu grid sem serviços!');
				$response->setError(new Error($messages, 500));
			} else {
				$codigosDosSubgrupos = array();
				foreach($servicos as $servico) {
					$conditions = array(
						array(
							'columnName' => 'CDFILIAL',
							'operator' => '=',
							'value' => $row['CDFILIAL']
						),
						array(
							'columnName' => 'CDCIA',
							'operator' => '=',
							'value' => $row['CDCIA']
						),
						array(
							'columnName' => 'CDMANCIA',
							'operator' => '=',
							'value' => $row['CDMANCIA']
						),
						array(
							'columnName' => 'NRSERVICOCIAFILI',
							'operator' => '=',
							'value' => $servico['NRSERVICOCIAFILI']
						),
							array(
							'columnName' => 'NRORG',
							'operator' => '=',
							'value' => $environment->getNrOrg()
						)
					);
					$subgrupos = $this->crudService->getFilteredDataSet('subgrusemam_subgrupom',$conditions)->getRows();
					if(empty($subgrupos)){
						array_push($messages,'O serviço '.$servico['DSSERVICOCIAFILI'].' não possui subgrupos.');
					} else {
						foreach ($subgrupos as $subgrupo) {
							array_push($codigosDosSubgrupos,array(
								'CDSUBGRU' => $subgrupo['CDSUBGRU'],
								'DSSUBGRU' => $subgrupo['DSSUBGRU'],
								'NRSERVICOCIAFILI' => $subgrupo['NRSERVICOCIAFILI'],
								'NRSEQSUBGRUSEMAM' => $subgrupo['NRSEQSUBGRUSEMAM'],
								'DSERVICOCIAFILI' => $servico['DSSERVICOCIAFILI'],
							));
						}
					}
				}
				if(!empty($messages)) {
					$messages = array_values(array_unique($messages));
					$response->setError(new Error($messages, 500));
				} else {
					foreach ($codigosDosSubgrupos as $codigoDoSubgrupo) {
						$conditions = array(
							array(
								'columnName' => 'CDFILIAL',
								'operator' => '=',
								'value' => $row['CDFILIAL']
							),
							array(
								'columnName' => 'CDCIA',
								'operator' => '=',
								'value' => $row['CDCIA']
							),
							array(
								'columnName' => 'CDMANCIA',
								'operator' => '=',
								'value' => $row['CDMANCIA']
							),
							array(
								'columnName' => 'CDSUBGRU',
								'operator' => '=',
								'value' => $codigoDoSubgrupo['CDSUBGRU']
							),
							array(
								'columnName' => 'NRSERVICOCIAFILI',
								'operator' => '=',
								'value' => $codigoDoSubgrupo['NRSERVICOCIAFILI']
							),
							array(
								'columnName' => 'NRSEQSUBGRUSEMAM',
								'operator' => '=',
								'value' => $codigoDoSubgrupo['NRSEQSUBGRUSEMAM']
							),
							array(
								'columnName' => 'NRORG',
								'operator' => '=',
								'value' => $environment->getNrOrg()
							)
						);
						$ciclos = $this->crudService->getFilteredDataSet('ciclosubgrusemam',$conditions)->getRows();
						if(empty($ciclos)){
							array_push($messages,'O subgrupo ' . $codigoDoSubgrupo['DSSUBGRU'] . ' do serviço ' . $codigoDoSubgrupo['DSERVICOCIAFILI'] . ' não possui ciclo.');
						}
					}
					if(!empty($messages)) {
						$messages = array_values(array_unique($messages));
						$response->setError(new Error($messages, 500));
					}
				}
			}
		} catch (\Exception $error){
			$response->setError($error);
		}
	}

	public function retornaSubgruposVigenciasSobrepostas($cdfilial, $cdcia, $cdmancia, $nrorg) {
		$stmt = $this->connection->prepare("SELECT SG.DSSUBGRU, TO_CHAR(SSM.DTINIVGSUMA, 'DD/MM/YYYY') AS DTINICIO, TO_CHAR(SSM.DTFIMVGSUMA, 'DD/MM/YYYY') AS DTFIM, SV.DSSERVICOCIAFILI, CL.SGCLASSE FROM SUBGRUSEMAM SSM INNER JOIN SUBGRUPO SG ON SG.CDSUBGRU = SSM.CDSUBGRU INNER JOIN SERVICOCIAFILI SV ON SV.CDFILIAL = SSM.CDFILIAL AND SV.CDCIA = SSM.CDCIA AND SV.NRSERVICOCIAFILI = SSM.NRSERVICOCIAFILI INNER JOIN CLASSE CL ON CL.CDCLASSE = SSM.CDCLASSE WHERE SSM.CDFILIAL = :CDFILIAL AND SSM.CDCIA = :CDCIA AND SSM.CDMANCIA = :CDMANCIA AND SSM.NRORG = :NRORG AND(TRUNC(SYSDATE) <= SSM.DTFIMVGSUMA) AND EXISTS(SELECT * FROM SUBGRUSEMAM WHERE CDFILIAL = SSM.CDFILIAL AND CDCIA = SSM.CDCIA AND CDMANCIA = SSM.CDMANCIA AND NRSERVICOCIAFILI = SSM.NRSERVICOCIAFILI AND CDCLASSE = SSM.CDCLASSE AND CDSUBGRU = SSM.CDSUBGRU AND NRORG = SSM.NRORG AND NRSEQSUBGRUSEMAM <> SSM.NRSEQSUBGRUSEMAM AND((SSM.DTINIVGSUMA BETWEEN DTINIVGSUMA AND DTFIMVGSUMA) OR(SSM.DTFIMVGSUMA BETWEEN DTINIVGSUMA AND DTFIMVGSUMA) OR(DTFIMVGSUMA BETWEEN SSM.DTINIVGSUMA AND SSM.DTFIMVGSUMA) OR(DTINIVGSUMA BETWEEN SSM.DTINIVGSUMA AND SSM.DTFIMVGSUMA))) ORDER BY DSSERVICOCIAFILI, SGCLASSE, DSSUBGRU, DTINICIO, DTFIM");
		$stmt->execute(array(
			'CDFILIAL' => $cdfilial,
			'CDCIA' => $cdcia,
			'CDMANCIA' => $cdmancia,
			'NRORG' => $nrorg
		));
		$result = $stmt->fetchAll(\PDO::FETCH_ASSOC);
		return $result;
	}


	public function alteraDataVigenciaSubgrupoMenuGrid($alteraDataIni, $novaDataIni, $alteraDataFim, $novaDataFim, $cdfilial, $cdcia, $cdmancia, $nrservicociafili, $cdclasse, $cdsubgru, $nrseqsubgrusemam) {
		$stmt = $this->connection->prepare("UPDATE SUBGRUSEMAM SET DTINIVGSUMA = CASE WHEN :ALTERA_DATA_INICIO = 'S' THEN TO_DATE(:NOVADATAINI, 'DD/MM/YYYY') ELSE DTINIVGSUMA END, DTFIMVGSUMA = CASE WHEN :ALTERA_DATA_FIM = 'S' THEN TO_DATE(:NOVADATAFIM, 'DD/MM/YYYY') ELSE DTFIMVGSUMA END WHERE CDFILIAL = :CDFILIAL AND CDCIA = :CDCIA AND CDMANCIA = :CDMANCIA AND NRSERVICOCIAFILI = :NRSERVICOCIAFILI AND CDCLASSE = :CDCLASSE AND CDSUBGRU = :CDSUBGRU AND NRSEQSUBGRUSEMAM = :NRSEQSUBGRUSEMAM");
		$stmt->execute(array(
			'ALTERA_DATA_INICIO' => $alteraDataIni,
			'NOVADATAINI' => $novaDataIni,
			'ALTERA_DATA_FIM' => $alteraDataFim,
			'NOVADATAFIM' => $novaDataFim,
			'CDFILIAL' => $cdfilial,
			'CDCIA' => $cdcia,
			'CDMANCIA' => $cdmancia,
			'NRSERVICOCIAFILI' => $nrservicociafili,
			'CDCLASSE' => $cdclasse,
			'CDSUBGRU' => $cdsubgru,
			'NRSEQSUBGRUSEMAM' => $nrseqsubgrusemam
		));
	}

	public function retornaSubgruposVigenciasDesatualizadas($novaDataIni, $novaDataFim, $cdfilial, $cdmancia, $cdcia) {
		$stmt = $this->connection->prepare("SELECT S.CDFILIAL, S.CDCIA, S.CDMANCIA, S.NRSERVICOCIAFILI, S.CDCLASSE, S.CDSUBGRU, S.NRSEQSUBGRUSEMAM, CASE WHEN(S.DTINIVGSUMA < :NOVADATAINI OR S.DTINIVGSUMA = M.DTINIVGMA OR S.DTINIVGSUMA IS NULL OR M.IDSITUAPROPCIA IN ('E', 'P')) THEN 'S' ELSE 'N' END AS ALTERA_DATA_INICIO, CASE WHEN(S.DTFIMVGSUMA = M.DTFIMVGMA OR S.DTFIMVGSUMA > :NOVADATAFIM OR S.DTFIMVGSUMA IS NULL OR M.IDSITUAPROPCIA IN ('E', 'P')) THEN 'S' ELSE 'N' END AS ALTERA_DATA_FIM FROM SUBGRUSEMAM S INNER JOIN MANUALCIAM M ON M.CDFILIAL = S.CDFILIAL AND M.CDCIA = S.CDCIA AND M.CDMANCIA = S.CDMANCIA WHERE S.CDFILIAL = :CDFILIAL AND S.CDCIA = :CDCIA AND S.CDMANCIA = :CDMANCIA AND ( S.DTINIVGSUMA < :NOVADATAINI OR S.DTINIVGSUMA = M.DTINIVGMA OR S.DTFIMVGSUMA = M.DTFIMVGMA OR S.DTFIMVGSUMA > :NOVADATAFIM OR S.DTINIVGSUMA IS NULL OR S.DTFIMVGSUMA IS NULL OR M.IDSITUAPROPCIA IN ('E', 'P'))");
		$stmt->execute(array(
			'NOVADATAINI' => $novaDataIni,
			'NOVADATAFIM' => $novaDataFim,
			'CDFILIAL' => $cdfilial,
			'CDCIA' => $cdcia,
			'CDMANCIA' => $cdmancia
		));
		$result = $stmt->fetchAll(\PDO::FETCH_ASSOC);
		return $result;
	}

	public function trySaveMenuGrid($request, $response) {

		$row = $request->getRow();

		$novaDataIni = $row['DTINIVGMA'];
		$novaDataFim = $row['DTFIMVGMA'];
		$cdfilial = $row['CDFILIAL'];
		$cdmancia = $row['CDMANCIA'];
		$cdcia = $row['CDCIA'];
		$nrorg = $row['NRORG'];

		try{

			$this->connection->beginTransaction();

			$subgruposVigenciasDesatualizadas = $this->retornaSubgruposVigenciasDesatualizadas($novaDataIni, $novaDataFim, $cdfilial, $cdmancia, $cdcia);

			for($i=0;$i<count($subgruposVigenciasDesatualizadas);$i++) {
				$subgrupoVigenciaDesatualizada = $subgruposVigenciasDesatualizadas[$i];
				$alteraDataIni = $subgrupoVigenciaDesatualizada['ALTERA_DATA_INICIO'];
				$alteraDataFim = $subgrupoVigenciaDesatualizada['ALTERA_DATA_FIM'];
				$nrservicociafili = $subgrupoVigenciaDesatualizada['NRSERVICOCIAFILI'];
				$cdclasse = $subgrupoVigenciaDesatualizada['CDCLASSE'];
				$cdsubgru = $subgrupoVigenciaDesatualizada['CDSUBGRU'];
				$nrseqsubgrusemam = $subgrupoVigenciaDesatualizada['NRSEQSUBGRUSEMAM'];

				$this->alteraDataVigenciaSubgrupoMenuGrid($alteraDataIni, $novaDataIni, $alteraDataFim, $novaDataFim, $cdfilial, $cdcia, $cdmancia, $nrservicociafili, $cdclasse, $cdsubgru, $nrseqsubgrusemam);

			}

			if($row['IDSITUAPROPCIA'] != self::MENU_GRID_DESENVOLVIMENTO) {

				$subgruposSobrepostos = $this->retornaSubgruposVigenciasSobrepostas($cdfilial, $cdcia, $cdmancia, $nrorg);

				if(!empty($subgruposSobrepostos)) {

					$this->connection->rollback();

					$subgrupos = array();

					for($i=0;$i<count($subgruposSobrepostos);$i++) {

						$subgrupoSobreposto = $subgruposSobrepostos[$i];

						$subgrupos[] = 'Serviço: ' . $subgrupoSobreposto['DSSERVICOCIAFILI'] . ' - ' . $subgrupoSobreposto['SGCLASSE'] . ' ' . 'Subgrupo: ' . $subgrupoSobreposto['DSSUBGRU'] . ' ' . $subgrupoSobreposto['DTINICIO'] . ' - ' . $subgrupoSobreposto['DTFIM'];

					}

					$response->addDataSet(new DataSet('errorMessage', $subgrupos));

					return false;

				}

			}

			$this->connection->commit();

			$rowsToSave = $this->crudService->getRowsToSave($request, 'manualciam');

			$this->crudService->save('manualciam', $rowsToSave);

		} catch(\Exception $e) {

			$response->setError(new Error($e->getMessage(), 500));
			$this->connection->rollback();

		}

	}

	public function tryRemoveItems($request, $response) {
		try{
			$dataset = $request->getDataSet()->getRows();
			$datasetCount = count($dataset);
			$connection = $this->entityManager->getConnection();
			$connection->beginTransaction();
			$receitas = array();
			$produtos = array();
			for ($i = 0; $i < count($dataset); $i++) {
				$dataset[$i]['__is_new'] = false;
				if ($dataset[$i]['ID'] == 'P') {
				 	array_push($produtos,$dataset[$i]);
				} else {
				 	array_push($receitas,$dataset[$i]);
				}
			}
			$receitas = new DataSet('recsubsemam'  , $receitas);
			$produtos = new DataSet('prodsubsemam' , $produtos);
			$this->dataSourceManager->delete($receitas);
			$this->dataSourceManager->delete($produtos);
			$connection->commit();
		} catch(\Exception $e){
			$response->setError(new Error($e->getMessage(), 500));
			$connection->rollback();
		}
	}

	public function geraWorkflowCopiaServico($request, $response) {
		$this->connection->beginTransaction();
		try {
			$row = $request->getRow();
			$listaErros = array();
			$workflowCpServMenu = array();

			$arrServclasse = $row['P_SERVCLASSE'];
			foreach ($arrServclasse as $servclasse) {
				$objServclasse = explode('|', $servclasse);
				$servico = $objServclasse[0];
				$classe = $objServclasse[1];

				$query = "SELECT SRV.CDFILIAL, SRV.CDCIA, SRV.CDMANCIA, SRV.NRSERVICOCIAFILI, SRV.CDCLASSE, SRV.NRORG, SCF.DSSERVICOCIAFILI||' - '||CLA.SGCLASSE AS IDSERVICOCLASSE, SRV.SITUACAO FROM (SELECT CDFILIAL, CDCIA, CDMANCIA, CDFILIAL AS CDFILIALORI, CDCIA AS CDCIAORI, NRSERVICOCIAFILI, CDCLASSE, 'A' AS SITUACAO, NRORG FROM SERVMANUALM UNION SELECT CDFILIALDES AS CDFILIAL, CDCIADES AS CDCIA, CDMANCIADES AS CDMANCIA, CDFILIALORI, CDCIAORI, NRSERVICOCIAFILI, CDCLASSE, 'P' AS SITUACAO, NRORG FROM WORKFLOWCPSERVMENU) SRV JOIN SERVICOCIAFILI SCF ON SCF.CDFILIAL = SRV.CDFILIALORI AND SCF.CDCIA = SRV.CDCIAORI AND SCF.NRSERVICOCIAFILI = SRV.NRSERVICOCIAFILI AND SCF.NRORG = SRV.NRORG JOIN CLASSE CLA ON CLA.CDCLASSE = SRV.CDCLASSE AND CLA.NRORG = SRV.NRORG JOIN (SELECT SCF_ALL.NRSERVICOCIAFILI, SCF_ALL.NRORG FROM SERVICOCIAFILI SCF_ORI JOIN SERVICOCIAFILI SCF_ALL ON SCF_ORI.DSSERVICOCIAFILI = SCF_ALL.DSSERVICOCIAFILI AND SCF_ORI.NRORG = SCF_ALL.NRORG WHERE SCF_ORI.CDFILIAL = :CDFILIAL_ORI AND SCF_ORI.CDCIA = :CDCIA_ORI AND SCF_ORI.NRSERVICOCIAFILI = :NRSERVICOCIAFILI) SCF_ALL ON SCF_ALL.NRSERVICOCIAFILI = SRV.NRSERVICOCIAFILI AND SCF_ALL.NRORG = SRV.NRORG WHERE SRV.CDFILIAL = :CDFILIAL_DES AND SRV.CDCIA = :CDCIA_DES AND SRV.CDMANCIA = :CDMANCIA_DES AND SRV.CDCLASSE = :CDCLASSE_DES AND SRV.NRORG = :NRORG";
				$params = array(
					"CDFILIAL_ORI" => $row['P_CDFILIALORI'],
					"CDCIA_ORI" => $row['P_CDCIAORI'],
					"NRSERVICOCIAFILI" => $servico,
					"CDFILIAL_DES" => $row['P_CDFILIALDES'],
					"CDCIA_DES" => $row['P_CDCIADES'],
					"CDMANCIA_DES" => $row['P_CDMANCIADES'],
					"CDCLASSE_DES" => $classe,
					"NRORG" => $row['P_NRORG']
				);

				$stmt = $this->connection->prepare($query);
				$stmt->execute($params);
				$result = $stmt->fetchAll(\PDO::FETCH_ASSOC);

				if (count($result) > 0) {
					foreach ($result as $itemRepetido) {
						$msg = $itemRepetido['SITUACAO'] == 'A'
							? "Serviço ".$itemRepetido['IDSERVICOCLASSE']." já existe no Menu Grid de destino."
							: "Workflow pendente para o serviço ".$itemRepetido['IDSERVICOCLASSE']." no Menu Grid de destino.";
						array_push($listaErros, $msg);
					}
				} else {
					array_push($workflowCpServMenu, array(
							'__is_new' => true,
							"CDFILIALDES" => $row['P_CDFILIALDES'],
							"CDCIADES" => $row['P_CDCIADES'],
							"CDMANCIADES" => $row['P_CDMANCIADES'],
							"NRSERVICOCIAFILI" => $servico,
							"CDCLASSE" => $classe,
							"CDFILIALORI" => $row['P_CDFILIALORI'],
							"CDCIAORI" => $row['P_CDCIAORI'],
							"CDMANCIAORI" => $row['P_CDMANCIAORI'],
							"IDCOPIAIMG" => $row['P_COPIA_IMAGEM'],
							"IDCOPIAPROCIA" => $row['COPIA_PRODCIA'],
							"NRORG" => $row['P_NRORG'],
							"CDOPERADOR" => $row['P_CDOPERADOR']
						)
					);
				}
			}

			if (count($listaErros) > 0) {
				$response->addDataSet(new DataSet("ListaErros", $listaErros));
			} else {
				$primaryKeys = array(
					"CDFILIAL" => $row['P_CDFILIALDES'],
					"CDCIA" => $row['P_CDCIADES'],
					"CDMANCIA" => $row['P_CDMANCIADES'],
				);
				$rowWf = array(
					'__is_new' => true,
					'NMTABELAWFLOW' => "MANUALCIAM",
					'NMCAMPOWFLOW' => "N/A",
					'DSINFORATUAL' => "N/A",
					'IDTIPOPERWFLOW' => '1',
					'DSPRIMARYKEY' => $this->workflowService->rowToStr($primaryKeys),
					'NRPROCESSOAPROVA' => 4,
					'NRITEMPROCAPROVA' => 26,
					'DSMOTIVOWFLOW' => 'N/A',
					'IDSITWORKFLOW' => '1',
					'NMITEMWFLOW' => $this->geraItemIncluidoCopiaServico($row)
				);
				$nrworkflow = $this->workflowService->createWorkFlowProcess($primaryKeys, array(), $rowWf);

				$rowsToSaveWfCpServMenu = array();
				foreach ($workflowCpServMenu as $rowToInsert) {
					$rowToInsert['NRWORKFLOW'] = $nrworkflow;
					array_push($rowsToSaveWfCpServMenu, $rowToInsert);
				}
				$dataSetWfCpServMenu = new DataSet('workflowcpservmenu', $rowsToSaveWfCpServMenu);
				$requestWfCpServMenu = new DTO\Request\DataSet($dataSetWfCpServMenu, '','','');
				$dataSourceNameWfCpServMenu = "workflowcpservmenu";
				$rowsToSave = $this->crudService->getRowsToSave($requestWfCpServMenu, $dataSourceNameWfCpServMenu);
				$this->crudService->save($dataSourceNameWfCpServMenu, $rowsToSave);
			}
			$this->connection->commit();
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), $e->getCode()));
			$this->connection->rollback();
		}
	}

	public function geraItemIncluidoCopiaServico($row) {
		$queryManualCiaFili = 'SELECT FIL.NMFILIAL, CIA.NMCIA, MAN.DSMANUAL FROM MANUALCIAM MAN JOIN FILIAL FIL ON FIL.CDFILIAL = MAN.CDFILIAL AND FIL.NRORG = MAN.NRORG JOIN COMPANHIA CIA ON CIA.CDCIA = MAN.CDCIA AND CIA.NRORG = MAN.NRORG WHERE MAN.CDFILIAL = :CDFILIAL AND MAN.CDCIA = :CDCIA AND MAN.CDMANCIA = :CDMANCIA AND MAN.NRORG = :NRORG';
		$queryServicos = "SELECT SCF.DSSERVICOCIAFILI||' ('||CLA.SGCLASSE||')' AS SERVCLASSE FROM SERVMANUALM SRV JOIN SERVICOCIAFILI SCF ON SCF.CDFILIAL = SRV.CDFILIAL AND SCF.CDCIA = SRV.CDCIA AND SCF.NRSERVICOCIAFILI = SRV.NRSERVICOCIAFILI AND SCF.NRORG = SRV.NRORG JOIN CLASSE CLA ON CLA.CDCLASSE = SRV.CDCLASSE AND CLA.NRORG = SRV.NRORG WHERE SRV.CDFILIAL = :CDFILIAL AND SRV.CDCIA = :CDCIA AND SRV.CDMANCIA = :CDMANCIA AND INSTR(:SERVCLASSE, SRV.NRSERVICOCIAFILI||'|'||SRV.CDCLASSE) <> 0  AND SRV.NRORG = :NRORG";

		$paramsMCFDes = array(
			"CDFILIAL" => $row['P_CDFILIALDES'],
			"CDCIA" => $row['P_CDCIADES'],
			"CDMANCIA" => $row['P_CDMANCIADES'],
			"NRORG" => $row['P_NRORG']
		);
		$stmtMCFDes = $this->connection->prepare($queryManualCiaFili);
		$stmtMCFDes->execute($paramsMCFDes);
		$resultMCFDes = $stmtMCFDes->fetch(\PDO::FETCH_ASSOC);

		$paramsMCFOri = array(
			"CDFILIAL" => $row['P_CDFILIALORI'],
			"CDCIA" => $row['P_CDCIAORI'],
			"CDMANCIA" => $row['P_CDMANCIAORI'],
			"NRORG" => $row['P_NRORG']
		);
		$stmtMCFOri = $this->connection->prepare($queryManualCiaFili);
		$stmtMCFOri->execute($paramsMCFOri);
		$resultMCFOri = $stmtMCFOri->fetch(\PDO::FETCH_ASSOC);

		$paramsServicos = array(
			"CDFILIAL" => $row['P_CDFILIALORI'],
			"CDCIA" => $row['P_CDCIAORI'],
			"CDMANCIA" => $row['P_CDMANCIAORI'],
			"SERVCLASSE" => implode('-', $row['P_SERVCLASSE']),
			"NRORG" => $row['P_NRORG']
		);
		$stmtServicos = $this->connection->prepare($queryServicos);
		$stmtServicos->execute($paramsServicos);
		$resultServicos = $stmtServicos->fetchAll(\PDO::FETCH_ASSOC);

		$unidadeOri = $resultMCFOri['NMFILIAL'];
		$companhiaOri = $resultMCFOri['NMCIA'];
		$menuOri = $resultMCFOri['DSMANUAL'];
		$servicosArr = array();
		foreach ($resultServicos as $servico) {
			array_push($servicosArr, $servico["SERVCLASSE"]);
		}
		$servicosOri = implode(' - ', $servicosArr);

		$unidadeDes = $resultMCFDes['NMFILIAL'];
		$companhiaDes = $resultMCFDes['NMCIA'];
		$menuDes = $resultMCFDes['DSMANUAL'];

		$copiaImagens = $row['P_COPIA_IMAGEM'] == 'S' ? 'Sim' : 'Não';
		$copiaProdCia = $row['COPIA_PRODCIA'] == 'S' ? 'Sim' : 'Não';

		return 'Unidade de Origem: '.$unidadeOri.'
		Companhia de Origem: '.$companhiaOri.'
		Menu Grid de Origem: '.$menuOri.'
		Serviço(s) de Origem: '.$servicosOri.'
		
		Unidade de Destino: '.$unidadeDes.'
		Companhia de Destino: '.$companhiaDes.'
		Menu Grid de Destino: '.$menuDes.'
		
		Copia Imagens: '.$copiaImagens.'
		Copia Itens da Cia: '.$copiaProdCia;
	}
	
	public function retornaQuantidadeComposicao($cdreceita, $produto){
		$query = "SELECT 'SR' AS TIPOCOMP, COUNT(*) AS QTD FROM SUBRECEITAM WHERE CDRECEITA = :CDRECEITA
                   UNION ALL
                  SELECT 'PR' AS TIPOCOMP, COUNT(*) AS QTD FROM PRORECEITAM WHERE CDRECEITA = :CDRECEITA";
		$param = array(
			"CDRECEITA" => $cdreceita
		);
		$stmt = $this->connection->prepare($query);
		$stmt->execute($param);
		$result = $stmt->fetchAll(\PDO::FETCH_ASSOC);
		if($produto) {
			return $result[1]['QTD'];	
		} else {
			return $result[0]['QTD'];
		}
	}
	
	public function modoDePreparo($cdreceita, $response){
		$query = "SELECT DSMPREPRECHTML 
				  FROM  MODPREPRECM
				  WHERE CDRECEITA = :CDRECEITA";
		$param = array(
			"CDRECEITA" => $cdreceita
		);
		$stmtMP = $this->connection->prepare($query);
		$stmtMP->execute($param);
		$result = $stmtMP->fetchAll(\PDO::FETCH_ASSOC);
		
		if(empty($result) || $result[0]["DSMPREPRECHTML"] == null){
			$this->setErrorMessage($cdreceita, "Modo de Preparo", $response);
		}
	}

	public function getOpcoesVariacaoReceita($cdreceita, $cdfilial){
		$query = "SELECT NROPCOES
					FROM VARIACAOREC
					WHERE CDRECEITA   = :CDRECEITA
					AND NRVARIACAOREC =
					  (SELECT MAX(NRVARIACAOREC)
					  FROM FILIRECEITA
					  WHERE CDFILIAL = :CDFILIAL
					  AND CDRECEITA  = :CDRECEITA
					  )";
		$param = array(
			"CDRECEITA" => $cdreceita,
			"CDFILIAL" => $cdfilial
		);
		$stmtMP = $this->connection->prepare($query);
		$stmtMP->execute($param);
		$result = $stmtMP->fetchAll(\PDO::FETCH_ASSOC);
		return $result;
	}
	public function getPreferenciasVariacaoReceita($cdreceita, $cdfilial){
		$query = "SELECT COUNT(SR.IDPREFERENCIA) AS IDPREFERENCIA
						FROM SUBRECEITAM SR
						JOIN RECEITAM RE
						ON SR.CDSUBRECEITA   = RE.CDRECEITA
						WHERE SR.NRORG       = :NRORG
						AND SR.CDRECEITA     = :CDRECEITA
						AND SR.NRVARIACAOREC =
						  (SELECT MAX(NRVARIACAOREC)
						  FROM FILIRECEITA
						  WHERE CDFILIAL = :CDFILIAL
						  AND CDRECEITA  = :CDRECEITA
						  )
						AND SR.IDPREFERENCIA = 'S'
						UNION ALL
						SELECT COUNT(PR.IDPREFERENCIA) AS IDPREFERENCIA
						FROM PRORECEITAM PR
						JOIN PRODUTO PD
						ON PR.CDPRODUTO      = PD.CDPRODUTO
						WHERE PR.NRORG       = :NRORG
						AND PR.CDRECEITA     = :CDRECEITA
						AND PR.NRVARIACAOREC =
						  (SELECT MAX(NRVARIACAOREC)
						  FROM FILIRECEITA
						  WHERE CDFILIAL = :CDFILIAL
						  AND CDRECEITA  = :CDRECEITA
						  )
						AND PR.IDPREFERENCIA = 'S'";
		$param = array(
			"CDRECEITA" => $cdreceita,
			"CDFILIAL" => $cdfilial,
			"NRORG" => $this->crudService->getEnvironment()->getNrOrg()
		);
		$stmtMP = $this->connection->prepare($query);
		$stmtMP->execute($param);
		$result = $stmtMP->fetchAll(\PDO::FETCH_ASSOC);
		if(empty($result)){
			return 0;
		} else {
			return array_reduce($result, function($i, $obj){
		    	return $i += $obj['IDPREFERENCIA'];
			});
		}
	}

	public function verificaFlex($cdreceita, $cdfilial, $response) {
		$query = "SELECT COUNT(IDRECFLEXIVEL) AS IDRECFLEXIVEL
						FROM RECEITAM
						WHERE CDRECEITA    = :CDRECEITA
						AND IDRECFLEXIVEL IN ('M', 'P')";
		$param = array(
			"CDRECEITA" => $cdreceita
		);
		$stmtMP = $this->connection->prepare($query);
		$stmtMP->execute($param);
		$result = $stmtMP->fetchAll(\PDO::FETCH_ASSOC);
		if(!empty($result)){
			if($result[0]['IDRECFLEXIVEL'] > 0){
				//Receita é flex
				$qtdOpcoes = $this->getOpcoesVariacaoReceita($cdreceita, $cdfilial);
				if(!empty($qtdOpcoes) && $qtdOpcoes[0]['NROPCOES'] > 0 ){
					$qtdPreferencias = $this->getPreferenciasVariacaoReceita($cdreceita, $cdfilial);
					if($qtdPreferencias !== $qtdOpcoes[0]['NROPCOES']){
						$this->setErrorMessage($cdreceita, " quantidade de opções igual a quantidade de preferencias selecionadas", $response);			
					}
				} else {
					$this->setErrorMessage($cdreceita, " quantidade de opções maior que 1", $response);		
				}
			}
		}
	}
	
	public function retornaSubreceita($cdreceita, $qtd, $response){
		if($qtd > 0) {
			for($i=0; $i<= $qtd; $i++) {
				
				$composicao = 
				   "SELECT CDSUBRECEITA
					FROM SUBRECEITAM
					WHERE CDRECEITA = :CDRECEITA";
				
				$modPred = 
				   "SELECT CDRECEITA, DSMPREPRECHTML 
					FROM modpreprecm
					where cdreceita = :CDRECEITA";
					
				$param = array(
					"CDRECEITA" => $cdreceita
				);
				
				$stmt = $this->connection->prepare($composicao);
				$stmt->execute($param);
				$result = $stmt->fetchAll(\PDO::FETCH_ASSOC);
				
				$stmtMP = $this->connection->prepare($modPred);
				$stmtMP->execute($param);
				$resultMP = $stmtMP->fetchAll(\PDO::FETCH_ASSOC);
				
				if(empty($resultMP)) {
					$this->setErrorMessage($cdreceita, "Modo de Preparo", $response);
				} else {
					for($j = 0; $j < sizeof($result); $j++){
						$newQtd = $this->retornaQuantidadeComposicao($result[$j]['CDSUBRECEITA'], false);
						$this->retornaSubreceita($result[$j]['CDSUBRECEITA'], $newQtd, $response);
						$this->modoDePreparo($result[$j]['CDSUBRECEITA'], $response);
					}
					return $result;
				}
			}
		} else {
			$qtdProd = $this->retornaQuantidadeComposicao($cdreceita, true);
			
			if($qtd == 0 && $qtdProd == 0){
				$this->setErrorMessage($cdreceita, "composição", $response);
			}
		}
	}
	
	public function setErrorMessage($cdreceita, $tipo, $response) {
		$query = "SELECT DSRECEITA
		          FROM RECEITAM
		          WHERE CDRECEITA = :CDRECEITA";
		$param = array(
			"CDRECEITA" => $cdreceita
		);
		$resultado = $this->connection->fetchAll($query, $param);
		if(!empty($resultado) && $resultado[0]['DSRECEITA']) {
			$arrayError = "Receita ".$resultado[0]['DSRECEITA']." não possui ".$tipo.".";
			return $response->setError(new Error($arrayError, 500));
		}
	}
	
	public function verificaComposicao($request, $response) {
		$row = $request->getRow();
		$cdreceita = $row['CDRECEITA'];
		$cdfilial = $row['CDFILIAL'];
		$this->verificaFlex($cdreceita, $cdfilial, $response);
		$this->modoDePreparo($cdreceita, $response);
		$qtdComp = $this->retornaQuantidadeComposicao($cdreceita, false);
		$this->retornaSubreceita($cdreceita, $qtdComp, $response);
	}
}