<?php

namespace Teknisa\COC\Services;

use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO;
use \Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\DataSet;

class ImportarItensFaturamentoService {
 
	const DELETE_PROPRECOSEM = "DELETE FROM PROPRECOSEM WHERE CDFILIAL = :CDFILIAL AND CDCIA = :CDCIA AND NRTABPRECO = :NRTABPRECO AND NRSEQPRECO = :NRSEQPRECO AND CDCLASSE = :CDCLASSE AND CDCICLO = :CDCICLO AND NRSERVICOCIAFILI = :NRSERVICOCIAFILI AND NRORG = :NRORG";
	const DELETE_PROPORCAOPRECO = "DELETE FROM PROPORCAOPRECO WHERE CDFILIAL = :CDFILIAL AND CDCIA = :CDCIA AND NRTABPRECO = :NRTABPRECO AND NRSEQPRECO = :NRSEQPRECO AND CDCLASSE = :CDCLASSE AND CDCICLO = :CDCICLO AND NRSERVICOCIAFILI = :NRSERVICOCIAFILI AND NRORG = :NRORG";
	const DELETE_SUBGRUTABPRECOM = "DELETE FROM SUBGRUTABPRECOM WHERE CDFILIAL = :CDFILIAL AND CDCIA = :CDCIA AND NRTABPRECO = :NRTABPRECO AND NRSERVICOCIAFILIPRECO = :NRSERVICOCIAFILIPRECO AND CDCLASSE = :CDCLASSE AND CDCICLO = :CDCICLO AND NRSEQPRECO = :NRSEQPRECO AND NRORG = :NRORG";
	const INSERT_PROPRECOSEM  = "INSERT INTO PROPRECOSEM (CDFILIAL, CDCIA, NRTABPRECO, NRSERVICOCIAFILI, CDCLASSE, CDCICLO, NRSEQPRECO, QTPAXINICIAL, QTPAXFINAL, VRPRESERVPRO, VRPRESERVDPRO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (:CDFILIAL, :CDCIA, :NRTABPRECO, :NRSERVICOCIAFILI, :CDCLASSE, :CDCICLO, :NRSEQPRECO, :QTPAXINICIAL, :QTPAXFINAL, :VRPRESERVPRO, :VRPRESERVDPRO, :NRORG, :IDATIVO, SYSDATE, SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO, :NRORGULTATU, :CDOPERULTATU)";
	const INSERT_TABPRECOMENUGRID = "INSERT INTO TABPRECOMENUGRID (CDFILIAL, CDCIA, NRTABPRECO, CDMANCIA, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) SELECT :CDFILIAL, :CDCIA, :NRTABPRECO, :CDMANCIA, :NRORG, :IDATIVO, SYSDATE, SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO, :NRORGULTATU, :CDOPERULTATU FROM TABPRECOSEM T WHERE CDFILIAL = :CDFILIAL AND CDCIA = :CDCIA AND NRTABPRECO = :NRTABPRECO AND NRORG = :NRORG AND NOT EXISTS (SELECT 1 FROM TABPRECOMENUGRID TM WHERE CDFILIAL = :CDFILIAL AND CDCIA = :CDCIA AND NRTABPRECO = :NRTABPRECO AND CDMANCIA = :CDMANCIA AND NRORG = :NRORG)";
	
	const FILE_COLUMNS = array(
            "UNIDADE" =>     array(
                   "CODIGO" => 0
            ),
            "COMPANHIA" =>   array(
                   "CODIGO" => 1
            ),
            "MENUGRID" =>    array(
                   "CODIGO" => 2
            ),
            "ORGANIZACAO" => array(
                   "CODIGO" => 3
            ),
            "SUBGRUPO" =>    array(
                   "CODIGO"     => 4,
                   "NOME"       => 11,
                   "SEQUENCIAL" => 5
            ),
            "CICLO" =>       array(
                   "CODIGO" => 6,
                   "NOME"   => 14
            ),
            "CLASSE" =>      array(
                   "CODIGO" => 7,
                   "NOME"   => 15
            ),
            "SERVICO" =>     array(
                   "CODIGO"      => 8,
                   "CODIGOPRECO" => 9,
                   "NOME"        => 10
            ),
            "VIGENCIA" =>    array(
                   "INICIO"  => 12,
                   "FIM"     => 13
            ),
            "LOADING" =>     array(
                   "TIPO"    => 16,
                   "VALOR"   => 17,
                   "UTILIZA" => 21
            ),
            "PRECO" =>       array(
                   "REAL"    => 18,
                   "DOLAR"   => 19
            ),
            "TABELAPROP" =>  array(
                   "UTILIZA" => 20
            ),
            "PAX" =>         array(
                   "COLUNA"  => 22
            )
    );

	protected $connection;
	protected $entityManager;

	public function __construct($environment, EntityManager $entityManager, $crudService) {
		$this->environment = $environment;
		$this->entityManager = $entityManager;
		$this->crudService = $crudService;
		$this->connection = $entityManager->getConnection();
	}

	public function deleteProprecosem($cdfilial, $cdcia, $nrtabpreco, $nrseqpreco, $cdclasse, $cdciclo, $nrservicociafili, $nrorg) {
		$params = array(
			"CDFILIAL" => $cdfilial,
			"CDCIA" => $cdcia,
			"NRTABPRECO" => $nrtabpreco,
			"NRSEQPRECO" => $nrseqpreco,
			"CDCLASSE" => $cdclasse,
			"CDCICLO" => $cdciclo,
			"NRSERVICOCIAFILI" => $nrservicociafili,
			"NRORG" => $nrorg
		);
		$this->executeQuery($params, self::DELETE_PROPRECOSEM);
	}

	public function deleteProporcaopreco($cdfilial, $cdcia, $nrtabpreco, $nrseqpreco, $cdclasse, $cdciclo, $nrservicociafili, $nrorg) {
		$params = array(
			"CDFILIAL" => $cdfilial,
			"CDCIA" => $cdcia,
			"NRTABPRECO" => $nrtabpreco,
			"NRSEQPRECO" => $nrseqpreco,
			"CDCLASSE" => $cdclasse,
			"CDCICLO" => $cdciclo,
			"NRSERVICOCIAFILI" => $nrservicociafili,
			"NRORG" => $nrorg
		);
		$this->executeQuery($params, self::DELETE_PROPORCAOPRECO);
	}

	public function deleteSubgrupoTabelaPreco($cdfilial, $cdcia, $nrtabpreco, $nrservicociafilipreco, $cdclasse, $cdciclo, $nrseqpreco, $nrorg) {
		$params = array(
			"CDFILIAL" 				=> $cdfilial,
			"CDCIA" 				=> $cdcia,
			"NRTABPRECO" 			=> $nrtabpreco,
			"NRSERVICOCIAFILIPRECO" => $nrservicociafilipreco,
			"CDCLASSE" 				=> $cdclasse,
			"CDCICLO" 				=> $cdciclo,
			"NRSEQPRECO" 			=> $nrseqpreco,
			"NRORG" 				=> $nrorg
		);
		$this->executeQuery($params, self::DELETE_SUBGRUTABPRECOM);
	}
	public function insertPrecoProporcional($row) {
	    $params = array(
	        "CDFILIAL" => $row['CDFILIAL'],
	        "CDCIA" => $row['CDCIA'],
	        "NRTABPRECO" => $row['NRTABPRECO'],
	        "NRSERVICOCIAFILI" => $row['NRSERVICOCIAFILI'],
	        "CDCLASSE" => $row['CDCLASSE'],
	        "CDCICLO" => $row['CDCICLO'],
	        "NRSEQPRECO" => $row['NRSEQPRECO'],
	        "QTPAXINICIAL" => $row['QTPAXINICIAL'],
	        "QTPAXFINAL" => $row['QTPAXFINAL'],
	        "VRPRESERVPRO" => $row['VRPRESERVPRO'],
	        "VRPRESERVDPRO" => $row['VRPRESERVDPRO'],
	        "NRORG" => $this->environment->getNrOrg(),
	        "IDATIVO" => 'S',
	        "NRORGINCLUSAO" => $this->environment->getNrOrg(),
	        "CDOPERINCLUSAO" => $this->environment->getCdOperador(),
	        "NRORGULTATU" => $this->environment->getNrOrg(),
	        "CDOPERULTATU" => $this->environment->getCdOperador()
	    );
	    $this->executeQuery($params, self::INSERT_PROPRECOSEM);
   }

    public function insertMenuGridTabelaPreco($cdfilial, $cdcia, $nrtabpreco, $cdmancia) {
	    $params = array(
	        "CDFILIAL" => $cdfilial,
	        "CDCIA" => $cdcia,
	        "NRTABPRECO" => $nrtabpreco,
	        "CDMANCIA" => $cdmancia,
	        "NRORG" => $this->environment->getNrOrg(),
	        "IDATIVO" => 'S',
	        "NRORGINCLUSAO" => $this->environment->getNrOrg(),
	        "CDOPERINCLUSAO" => $this->environment->getCdOperador(),
	        "NRORGULTATU" => $this->environment->getNrOrg(),
	        "CDOPERULTATU" => $this->environment->getCdOperador()
	    );
	   	$this->executeQuery($params, self::INSERT_TABPRECOMENUGRID);
    }

    public function saveSubgrupoTabelaPreco($data) {
        $dataSet = new DataSet('subgrutabprecom', $data);
        $request = new DTO\Request\DataSet($dataSet, '','','');
        $rowToSave = $this->crudService->getRowsToSave($request, 'subgrutabprecom');
        $this->crudService->save('subgrutabprecom', $rowToSave);
    }
    public function savePrecoseciam($row) {
        $dataSet = new DataSet('precoseciam', [$row]);
        $request = new DTO\Request\DataSet($dataSet, '','','');
        $rowToSave = $this->crudService->getRowsToSave($request, 'precoseciam');
        $this->crudService->save('precoseciam', $rowToSave);
        return $this->crudService->getColumnsToReturn()[0]['NRSEQPRECO'];
    }

    public function verificaPlanoVoo($existe) {
        $conditions = array(
            array (
                "columnName" => "CDFILIAL",
                "operator" => "=",
                "value" => $existe[0]['CDFILIAL']
            ),
            array (
                "columnName" => "CDCIA",
                "operator" => "=",
                "value" => $existe[0]['CDCIA']
            ),
            array (
                "columnName" => "NRSERVICOCIAFILI",
                "operator" => "=",
                "value" => $existe[0]['NRSERVICOCIAFILI']
            ),
            array (
                "columnName" => "DTINIHRPLAVOOPV",
                "operator" => "=",
                "value" => substr($existe[0]['DTINIVIGSE'],0,10)
            ),
            array (
                "columnName" => "DTFIMHRPLAVOOPV",
                "operator" => "=",
                "value" => substr($existe[0]['DTFIMVIGSE'],0,10)
            ),
            array (
                "columnName" => "CDCLASSE",
                "operator" => "=",
                "value" => $existe[0]['CDCLASSE']
            ),
            array (
                "columnName" => "CDCICLO",
                "operator" => "=",
                "value" => $existe[0]['CDCICLO']
            ),
            array (
                "columnName" => "NRORG",
                "operator" => "=",
                "value" => $this->environment->getNrOrg()
            ),
        );
        
        $dataSet = $this->crudService->getFilteredDataSet('planodevoo_between_vigencia', $conditions);
        
        if(empty($dataSet->getRows()))
            return [];
        else 
            return $dataSet->getRows();
    }

	private function executeQuery ($params, $sql){
		$query = $this->connection->prepare($sql);
		$query->execute($params);
	}

	public function getFileColumns() {
		return SELF::FILE_COLUMNS;
	}
	public function getColumnsUnidade() {
		return SELF::FILE_COLUMNS["UNIDADE"];
	}
	public function getColumnsCompanhia() {
		return SELF::FILE_COLUMNS["COMPANHIA"];
	}
	public function getColumnsMenuGrid() {
		return SELF::FILE_COLUMNS["MENUGRID"];
	}
	public function getColumnsOrg() {
		return SELF::FILE_COLUMNS["ORGANIZACAO"];
	}
	public function getColumnsSubGrupo() {
		return SELF::FILE_COLUMNS["SUBGRUPO"];
	}
	public function getColumnsCiclo() {
		return SELF::FILE_COLUMNS["CICLO"];
	}
	public function getColumnsClasse() {
		return SELF::FILE_COLUMNS["CLASSE"];
	}
	public function getColumnsServico() {
		return SELF::FILE_COLUMNS["SERVICO"];
	}
	public function getColumnsVigencia() {
		return SELF::FILE_COLUMNS["VIGENCIA"];
	}
	public function getColumnsLoading() {
		return SELF::FILE_COLUMNS["LOADING"];
	}
	public function getColumnsPreco() {
		return SELF::FILE_COLUMNS["PRECO"];
	}
	public function getColumnsTabelaProp() {
		return SELF::FILE_COLUMNS["TABELAPROP"];
	}
	public function getColumnsPax() {
		return SELF::FILE_COLUMNS["PAX"];
	}
}