<?php

namespace Teknisa\COC\Services;

use \Doctrine\ORM\EntityManager;

class MenuDesignService {
	protected $entityManager;
	protected $crudService;

	public function __construct(EntityManager $entityManager, $crudService) {
		$this->entityManager = $entityManager;
		$this->crudService = $crudService;
	}

	public function getOldFgfotosubsemam($cdcia, $cdfilial, $cdciclo, $cdclasse, $cdmancia, $nrservicociafili, $nrseqsubgrusemam, $nrorg){
		$params = array("cdcia" => $cdcia,
						"cdfilial" => $cdfilial,
						"cdclasse" => $cdclasse,
						"cdciclo" => $cdciclo,
						"cdmancia" => $cdmancia,
						"nrservicociafili" => $nrservicociafili,
						"nrseqsubgrusemam" => $nrseqsubgrusemam,
						"nrorg" => $nrorg
		);
		$conn = $this->entityManager->getConnection();
		$rows = $conn->fetchAll("SELECT FGFOTOSUBSEMAM FROM CICLOSUBGRUSEMAM WHERE CDCIA = :cdcia AND CDFILIAL = :cdfilial AND CDCLASSE = :cdclasse AND CDCICLO = :cdciclo AND CDMANCIA = :cdmancia AND NRSERVICOCIAFILI = :nrservicociafili AND NRSEQSUBGRUSEMAM = :nrseqsubgrusemam AND NRORG = :nrorg", $params);
		
		$fgfotosubsemam = (isset($rows[0]) && isset($rows[0]['FGFOTOSUBSEMAM'])) ? $rows[0]['FGFOTOSUBSEMAM'] : null;
		$fgfotosubsemamt = (isset($rows[0]) && isset($rows[0]['FGFOTOSUBSEMAMT'])) ? $rows[0]['FGFOTOSUBSEMAMT'] : null;
		return array($fgfotosubsemam,$fgfotosubsemamt);
	}

	public function checkFileForDelete($fgfotosubsemam, $nrorg){
		$params = array(
			"FGFOTOSUBSEMAM" => $fgfotosubsemam,
			"NRORG" => $nrorg
		);
		$conn = $this->entityManager->getConnection();
		$filerepeat = $conn->fetchAll("SELECT COUNT(*) AS FILEREPEAT FROM CICLOSUBGRUSEMAM WHERE FGFOTOSUBSEMAM = :FGFOTOSUBSEMAM AND NRORG = :NRORG", $params);
		if ($filerepeat[0]['FILEREPEAT'] <= 1) {
			$this->deleteFile($fgfotosubsemam, $nrorg);
		}
	}

	private function deleteFile($fgfotosubsemam, $nrorg){
		$sql = "INSERT INTO FSGARBAGE (FILEURL, NRORG) VALUES (:FILEURL, :NRORG)";
		$params = array(
			"FILEURL" => $fgfotosubsemam,
			"NRORG" => $nrorg
		);

		$conn = $this->entityManager->getConnection();
		$conn->beginTransaction();

		try {
			$query = $this->entityManager->getConnection()->prepare($sql);
			$query->execute($params);
			$conn->commit();
		} catch(\Exception $e) {
			$conn->rollback();
		}
	}

	public function updateSubgrupos($P_CDFILIAL, $P_CDCIA, $P_VIGENCIAFIMMANUAL_OLD, $P_VIGENCIAINIMANUAL, $P_CDMANCIA, $P_VIGENCIAINIMANUAL_OLD, $P_VIGENCIAFIMMANUAL) {
		$params = array(
			"P_VIGENCIAINIMANUAL_OLD" =>  $P_VIGENCIAINIMANUAL_OLD,
			"P_VIGENCIAINIMANUAL" =>  $P_VIGENCIAINIMANUAL,
			"P_VIGENCIAFIMMANUAL_OLD" =>  $P_VIGENCIAFIMMANUAL_OLD,
			"P_VIGENCIAFIMMANUAL" =>  $P_VIGENCIAFIMMANUAL,
			"P_CDFILIAL" =>  $P_CDFILIAL,
			"P_CDCIA" =>  $P_CDCIA,
			"P_CDMANCIA" =>  $P_CDMANCIA
		);
		$sql = "UPDATE SUBGRUSEMAM SET DTINIVGSUMA = CASE WHEN DTINIVGSUMA = TO_DATE(:P_VIGENCIAINIMANUAL_OLD, 'DD/MM/YYYY') THEN TO_DATE(:P_VIGENCIAINIMANUAL, 'DD/MM/YYYY') WHEN DTINIVGSUMA < TO_DATE(:P_VIGENCIAINIMANUAL, 'DD/MM/YYYY') THEN TO_DATE(:P_VIGENCIAINIMANUAL, 'DD/MM/YYYY') ELSE DTINIVGSUMA END, DTFIMVGSUMA = CASE WHEN DTFIMVGSUMA = TO_DATE(:P_VIGENCIAFIMMANUAL_OLD, 'DD/MM/YYYY') THEN TO_DATE(:P_VIGENCIAFIMMANUAL, 'DD/MM/YYYY') WHEN DTFIMVGSUMA > TO_DATE(:P_VIGENCIAFIMMANUAL, 'DD/MM/YYYY') THEN TO_DATE(:P_VIGENCIAFIMMANUAL, 'DD/MM/YYYY') WHEN DTFIMVGSUMA < CASE WHEN DTINIVGSUMA = TO_DATE(:P_VIGENCIAINIMANUAL_OLD, 'DD/MM/YYYY') THEN TO_DATE(:P_VIGENCIAINIMANUAL, 'DD/MM/YYYY') WHEN DTINIVGSUMA < TO_DATE(:P_VIGENCIAINIMANUAL, 'DD/MM/YYYY') THEN TO_DATE(:P_VIGENCIAINIMANUAL, 'DD/MM/YYYY') ELSE DTINIVGSUMA END THEN TO_DATE(:P_VIGENCIAFIMMANUAL, 'DD/MM/YYYY') ELSE DTFIMVGSUMA END WHERE CDFILIAL = :P_CDFILIAL AND CDCIA = :P_CDCIA AND CDMANCIA = :P_CDMANCIA";
		$query = $this->entityManager->getConnection()->prepare($sql);
		$query->execute($params);
	}

	public function extendDateSubgrupo($row){
		$connection = $this->entityManager->getConnection();
		if(isset($row['DTFIMVGMA'])){
			$sqlDtFinal = "UPDATE SUBGRUSEMAM
					SET DTFIMVGSUMA   = :DTFIM
	  				WHERE CDFILIAL = :CDFILIAL
	  				AND CDCIA      = :CDCIA
	  				AND CDMANCIA   = :CDMANCIA
	  				AND NRORG   = :NRORG
	  				AND DTFIMVGSUMA =
	  				(SELECT DTFIMVGMA
	  				FROM MANUALCIAM
	  				WHERE CDFILIAL = :CDFILIAL
	  				AND CDCIA      = :CDCIA
	  				AND CDMANCIA   = :CDMANCIA
	  				AND NRORG   = :NRORG)";

			$paramsDtFinal = array(
				'CDFILIAL' => $row['CDFILIAL'],
				'CDCIA' => $row['CDCIA'],
				'CDMANCIA' => $row['CDMANCIA'],
				'DTFIM' => $row['DTFIMVGMA'],
				'NRORG' => $row['NRORG']
			);
			$queryDtFim = $connection->prepare($sqlDtFinal);
			$queryDtFim->execute($paramsDtFinal);
		}


		if(isset($row['DTINIVGMA'])){
			$sqlDtInicial = "UPDATE SUBGRUSEMAM
					SET DTINIVGSUMA   = :DTINI
					WHERE DTINIVGSUMA =
	  				(SELECT DTINIVGMA
	  				FROM MANUALCIAM
	  				WHERE CDFILIAL = :CDFILIAL
	  				AND CDCIA      = :CDCIA
	  				AND CDMANCIA   = :CDMANCIA)";

			$paramsDtInicial = array(
				'CDFILIAL' => $row['CDFILIAL'],
				'CDCIA' => $row['CDCIA'],
				'CDMANCIA' => $row['CDMANCIA'],
				'DTINI' => $row['DTINIVGMA']
			);
			$queryDtIni = $connection->prepare($sqlDtInicial);
			$queryDtIni->execute($paramsDtInicial);
		}
	}

	public function verifyOverlapSubgrupo($row){
		$dataSourceName = 'coc03600_validate_subgrusemam_date';
		$conditions = array(
			array(
				'columnName' => 'CDFILIAL',
				'operator' => '=',
				'value' => $row['CDFILIAL']
			),
			array(
				'columnName' => 'CDCIA',
				'operator' => '=',
				'value' => $row['CDCIA']
			),
			array(
				'columnName' => 'CDMANCIA',
				'operator' => '=',
				'value' => $row['CDMANCIA']
			),
			array(
				'columnName' => 'NRORG',
				'operator' => '=',
				'value' => $this->crudService->getEnvironment()->getNrOrg()
			)
		);
		return $this->crudService->getFilteredDataSet($dataSourceName, $conditions)->getRows();
	}

	public function manipulateDataError($data, $row){
		$codigo_subgrupo = '_';
		foreach($data as $subgrupo){
			$codigo_subgrupo = $codigo_subgrupo.$subgrupo['CODIGO_COMPLETO'].'_';
		}
		$conditions = array(
			array(
				'columnName' => 'CDFILIAL',
				'operator' => '=',
				'value' => $row['CDFILIAL']
			),
			array(
				'columnName' => 'CDCIA',
				'operator' => '=',
				'value' => $row['CDCIA']
			),
			array(
				'columnName' => 'CDMANCIA',
				'operator' => '=',
				'value' => $row['CDMANCIA']
			),
			array(
				'columnName' => 'NRORG',
				'operator' => '=',
				'value' => $this->crudService->getEnvironment()->getNrOrg()
			),
			array(
				'columnName' => 'CODIGO_COMPLETO',
				'operator' => '=',
				'value' => $codigo_subgrupo
			)
		);

		$dataSet = $this->crudService->getFilteredDataSet('coc03600_get_subgrupo_sobreposto', $conditions)->getRows();
        $subgrupos = array();
        foreach($dataSet as $subgrupo){
			$subgrupos[] = $subgrupo['DESCRIPTION'];
        }
        return $subgrupos;
	}
}